import React from 'react';
import { FormProps, FormItemProps, RowProps, ColProps } from 'antd';
import './index.less';
export declare type valueType = 'text' | 'select' | 'treeSelect' | 'date' | 'dateRange' | 'cascader' | 'option' | 'custom';
export interface ActionType {
    getFieldsValue: () => any;
    setFieldsValue: (val: any) => void;
    resetFields: () => void;
}
export interface IField extends FormItemProps {
    label?: React.ReactNode;
    name: string;
    valueType?: valueType;
    valueEnum?: Map<any, any>;
    fieldProps?: any;
    order?: number;
    show?: boolean;
}
export interface FilterFormProps {
    className?: string;
    style?: React.CSSProperties;
    formProps?: FormProps;
    rowProps?: RowProps;
    colProps?: ColProps;
    options: IField[];
    column?: number;
    showAction?: boolean;
    onSearch?: (values: any) => void;
    onReset?: () => void;
    renderCustomAction?: () => React.ReactNode;
}
declare const _default: React.ForwardRefExoticComponent<FilterFormProps & React.RefAttributes<unknown>>;
export default _default;
