import React from 'react';
import { FormProps } from 'antd/lib/form';
import { TableProps, ColumnProps } from 'antd/lib/table';
import { PresetStatusColorType } from 'antd/lib/_util/colors';
import { IProps as drawerProps } from '@/DrawerFilter';
import { ValueType as TableFilterValueType } from '../TableFilter';
import { ToolbarProps } from './Toolbar';
import './index.less';
export interface RequestData {
    success: boolean;
    data?: any[];
    total: number;
}
export declare type ValueType = TableFilterValueType | 'option';
declare type IValueEnum = Map<any, string | {
    text: string;
    status: PresetStatusColorType;
}>;
interface IPagination {
    current: number;
    pageSize: number;
}
export interface ProColumn<T = any> extends ColumnProps<T> {
    dataIndex: string;
    valueType?: ValueType;
    valueEnum?: IValueEnum;
    search?: boolean;
    hideInTable?: boolean;
    dateTimeFormat?: string;
    fieldProps?: any;
    order?: number;
}
export interface ActionType {
    reload: (resetPageIndex?: boolean) => void;
    getFilterValue: () => object;
    setFilterValue: (val: any) => void;
    resetFilter: () => void;
}
export interface ProTableProps<Column> extends TableProps<Column> {
    id?: string;
    request: (params: object, sort: {
        [key: string]: 'ascend' | 'descend';
    }, filter: {
        [key: string]: React.ReactText[];
    }) => Promise<RequestData>;
    params?: object;
    columns: Array<ProColumn<Column>>;
    className?: string;
    style?: React.CSSProperties;
    tableClassName?: string;
    tableStyle?: React.CSSProperties;
    formClassName?: string;
    formStyle?: React.CSSProperties;
    formProps?: FormProps;
    toolbar?: ToolbarProps;
    actionRef?: React.MutableRefObject<ActionType | undefined> | ((actionRef: ActionType) => void);
    defaultPagination?: IPagination;
    formMode?: 'fixed' | 'static';
    defaultCollapsed?: boolean;
    drawerProps?: drawerProps;
    remember?: boolean;
    onFilterSearch?: (values: any) => void;
    onFilterReset?: () => void;
}
declare const ProTable: <RecordType extends object = any>(props: ProTableProps<RecordType>) => JSX.Element;
export default ProTable;
