import React from 'react';
import { FormProps, FormItemProps } from 'antd/lib/form';
import './index.less';
export declare type ValueType = 'text' | 'select' | 'treeSelect' | 'date' | 'dateRange' | 'cascader' | 'option' | 'custom';
export interface ActionType {
    getFieldsValue: () => any;
    setFieldsValue: (val: any) => void;
    resetFields: () => void;
}
export interface IField extends FormItemProps {
    name: string;
    valueType?: ValueType;
    valueEnum?: Map<any, any>;
    fieldProps?: any;
    order?: number;
    show?: boolean;
}
export interface TableFilterProps {
    formProps?: FormProps;
    fields: IField[];
    onSearch: (values: any) => void;
    onReset: () => void;
    className?: string;
    style?: React.CSSProperties;
    actionRef?: React.MutableRefObject<ActionType | undefined> | ((actionRef: ActionType) => void);
    mode?: 'fixed' | 'static';
    defaultCollapsed?: boolean;
}
declare const TableFilter: React.FC<TableFilterProps>;
export default TableFilter;
