import React, { createContext, useContext, useEffect, forwardRef, createElement, Children, isValidElement, useState, useRef, useImperativeHandle, memo } from 'react';
import classnames from 'classnames';
import { Select as Select$1, TreeSelect as TreeSelect$1, Input as Input$1, DatePicker as DatePicker$1, Cascader as Cascader$1, Form, Row, Col, Space, Button, Drawer, Typography, Checkbox, Popover, Badge, ConfigProvider, Table, Card, Descriptions, Divider } from 'antd';
import { useHistory } from 'react-router-dom';
import zhCN from 'antd/lib/locale/zh_CN';
import moment from 'moment';
import _ from 'lodash';

function styleInject(css, ref) {
  if ( ref === void 0 ) ref = {};
  var insertAt = ref.insertAt;

  if (!css || typeof document === 'undefined') { return; }

  var head = document.head || document.getElementsByTagName('head')[0];
  var style = document.createElement('style');
  style.type = 'text/css';

  if (insertAt === 'top') {
    if (head.firstChild) {
      head.insertBefore(style, head.firstChild);
    } else {
      head.appendChild(style);
    }
  } else {
    head.appendChild(style);
  }

  if (style.styleSheet) {
    style.styleSheet.cssText = css;
  } else {
    style.appendChild(document.createTextNode(css));
  }
}

var css_248z = "/* 字体 */\n/* 行高 */\n@import '~antd/dist/antd.css';\n.iLab-caption {\n  display: flex;\n  align-items: center;\n  font-size: 14px;\n  line-height: 22px;\n  font-weight: 600;\n}\n.iLab-caption-sign {\n  display: inline-block;\n  width: 3px;\n  height: 12px;\n  background: #00a4f5;\n  margin-right: 8px;\n}\n";
styleInject(css_248z);

function Caption(_ref) {
  var className = _ref.className,
      style = _ref.style,
      children = _ref.children;
  return /*#__PURE__*/React.createElement("p", {
    className: classnames('iLab-caption', className),
    style: style
  }, /*#__PURE__*/React.createElement("span", {
    className: "iLab-caption-sign"
  }), children);
}

function ownKeys(object, enumerableOnly) {
  var keys = Object.keys(object);

  if (Object.getOwnPropertySymbols) {
    var symbols = Object.getOwnPropertySymbols(object);
    enumerableOnly && (symbols = symbols.filter(function (sym) {
      return Object.getOwnPropertyDescriptor(object, sym).enumerable;
    })), keys.push.apply(keys, symbols);
  }

  return keys;
}

function _objectSpread2(target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = null != arguments[i] ? arguments[i] : {};
    i % 2 ? ownKeys(Object(source), !0).forEach(function (key) {
      _defineProperty(target, key, source[key]);
    }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) {
      Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
    });
  }

  return target;
}

function _typeof(obj) {
  "@babel/helpers - typeof";

  return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) {
    return typeof obj;
  } : function (obj) {
    return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
  }, _typeof(obj);
}

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) {
  try {
    var info = gen[key](arg);
    var value = info.value;
  } catch (error) {
    reject(error);
    return;
  }

  if (info.done) {
    resolve(value);
  } else {
    Promise.resolve(value).then(_next, _throw);
  }
}

function _asyncToGenerator(fn) {
  return function () {
    var self = this,
        args = arguments;
    return new Promise(function (resolve, reject) {
      var gen = fn.apply(self, args);

      function _next(value) {
        asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value);
      }

      function _throw(err) {
        asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err);
      }

      _next(undefined);
    });
  };
}

function _defineProperty(obj, key, value) {
  if (key in obj) {
    Object.defineProperty(obj, key, {
      value: value,
      enumerable: true,
      configurable: true,
      writable: true
    });
  } else {
    obj[key] = value;
  }

  return obj;
}

function _objectWithoutPropertiesLoose(source, excluded) {
  if (source == null) return {};
  var target = {};
  var sourceKeys = Object.keys(source);
  var key, i;

  for (i = 0; i < sourceKeys.length; i++) {
    key = sourceKeys[i];
    if (excluded.indexOf(key) >= 0) continue;
    target[key] = source[key];
  }

  return target;
}

function _objectWithoutProperties(source, excluded) {
  if (source == null) return {};

  var target = _objectWithoutPropertiesLoose(source, excluded);

  var key, i;

  if (Object.getOwnPropertySymbols) {
    var sourceSymbolKeys = Object.getOwnPropertySymbols(source);

    for (i = 0; i < sourceSymbolKeys.length; i++) {
      key = sourceSymbolKeys[i];
      if (excluded.indexOf(key) >= 0) continue;
      if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue;
      target[key] = source[key];
    }
  }

  return target;
}

function _slicedToArray(arr, i) {
  return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest();
}

function _arrayWithHoles(arr) {
  if (Array.isArray(arr)) return arr;
}

function _iterableToArrayLimit(arr, i) {
  var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"];

  if (_i == null) return;
  var _arr = [];
  var _n = true;
  var _d = false;

  var _s, _e;

  try {
    for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) {
      _arr.push(_s.value);

      if (i && _arr.length === i) break;
    }
  } catch (err) {
    _d = true;
    _e = err;
  } finally {
    try {
      if (!_n && _i["return"] != null) _i["return"]();
    } finally {
      if (_d) throw _e;
    }
  }

  return _arr;
}

function _unsupportedIterableToArray(o, minLen) {
  if (!o) return;
  if (typeof o === "string") return _arrayLikeToArray(o, minLen);
  var n = Object.prototype.toString.call(o).slice(8, -1);
  if (n === "Object" && o.constructor) n = o.constructor.name;
  if (n === "Map" || n === "Set") return Array.from(o);
  if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen);
}

function _arrayLikeToArray(arr, len) {
  if (len == null || len > arr.length) len = arr.length;

  for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i];

  return arr2;
}

function _nonIterableRest() {
  throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}

var IconContext = /*#__PURE__*/createContext({});

function _defineProperty$1(obj, key, value) {
  if (key in obj) {
    Object.defineProperty(obj, key, {
      value: value,
      enumerable: true,
      configurable: true,
      writable: true
    });
  } else {
    obj[key] = value;
  }

  return obj;
}

function ownKeys$1(object, enumerableOnly) {
  var keys = Object.keys(object);

  if (Object.getOwnPropertySymbols) {
    var symbols = Object.getOwnPropertySymbols(object);
    enumerableOnly && (symbols = symbols.filter(function (sym) {
      return Object.getOwnPropertyDescriptor(object, sym).enumerable;
    })), keys.push.apply(keys, symbols);
  }

  return keys;
}

function _objectSpread2$1(target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = null != arguments[i] ? arguments[i] : {};
    i % 2 ? ownKeys$1(Object(source), !0).forEach(function (key) {
      _defineProperty$1(target, key, source[key]);
    }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys$1(Object(source)).forEach(function (key) {
      Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
    });
  }

  return target;
}

function _arrayWithHoles$1(arr) {
  if (Array.isArray(arr)) return arr;
}

function _iterableToArrayLimit$1(arr, i) {
  var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"];

  if (_i == null) return;
  var _arr = [];
  var _n = true;
  var _d = false;

  var _s, _e;

  try {
    for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) {
      _arr.push(_s.value);

      if (i && _arr.length === i) break;
    }
  } catch (err) {
    _d = true;
    _e = err;
  } finally {
    try {
      if (!_n && _i["return"] != null) _i["return"]();
    } finally {
      if (_d) throw _e;
    }
  }

  return _arr;
}

function _arrayLikeToArray$1(arr, len) {
  if (len == null || len > arr.length) len = arr.length;

  for (var i = 0, arr2 = new Array(len); i < len; i++) {
    arr2[i] = arr[i];
  }

  return arr2;
}

function _unsupportedIterableToArray$1(o, minLen) {
  if (!o) return;
  if (typeof o === "string") return _arrayLikeToArray$1(o, minLen);
  var n = Object.prototype.toString.call(o).slice(8, -1);
  if (n === "Object" && o.constructor) n = o.constructor.name;
  if (n === "Map" || n === "Set") return Array.from(o);
  if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray$1(o, minLen);
}

function _nonIterableRest$1() {
  throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}

function _slicedToArray$1(arr, i) {
  return _arrayWithHoles$1(arr) || _iterableToArrayLimit$1(arr, i) || _unsupportedIterableToArray$1(arr, i) || _nonIterableRest$1();
}

function _objectWithoutPropertiesLoose$1(source, excluded) {
  if (source == null) return {};
  var target = {};
  var sourceKeys = Object.keys(source);
  var key, i;

  for (i = 0; i < sourceKeys.length; i++) {
    key = sourceKeys[i];
    if (excluded.indexOf(key) >= 0) continue;
    target[key] = source[key];
  }

  return target;
}

function _objectWithoutProperties$1(source, excluded) {
  if (source == null) return {};
  var target = _objectWithoutPropertiesLoose$1(source, excluded);
  var key, i;

  if (Object.getOwnPropertySymbols) {
    var sourceSymbolKeys = Object.getOwnPropertySymbols(source);

    for (i = 0; i < sourceSymbolKeys.length; i++) {
      key = sourceSymbolKeys[i];
      if (excluded.indexOf(key) >= 0) continue;
      if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue;
      target[key] = source[key];
    }
  }

  return target;
}

function _typeof$1(obj) {
  "@babel/helpers - typeof";

  return _typeof$1 = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) {
    return typeof obj;
  } : function (obj) {
    return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
  }, _typeof$1(obj);
}

/**
 * Take input from [0, n] and return it as [0, 1]
 * @hidden
 */
function bound01(n, max) {
    if (isOnePointZero(n)) {
        n = '100%';
    }
    var isPercent = isPercentage(n);
    n = max === 360 ? n : Math.min(max, Math.max(0, parseFloat(n)));
    // Automatically convert percentage into number
    if (isPercent) {
        n = parseInt(String(n * max), 10) / 100;
    }
    // Handle floating point rounding errors
    if (Math.abs(n - max) < 0.000001) {
        return 1;
    }
    // Convert into [0, 1] range if it isn't already
    if (max === 360) {
        // If n is a hue given in degrees,
        // wrap around out-of-range values into [0, 360] range
        // then convert into [0, 1].
        n = (n < 0 ? (n % max) + max : n % max) / parseFloat(String(max));
    }
    else {
        // If n not a hue given in degrees
        // Convert into [0, 1] range if it isn't already.
        n = (n % max) / parseFloat(String(max));
    }
    return n;
}
/**
 * Need to handle 1.0 as 100%, since once it is a number, there is no difference between it and 1
 * <http://stackoverflow.com/questions/7422072/javascript-how-to-detect-number-as-a-decimal-including-1-0>
 * @hidden
 */
function isOnePointZero(n) {
    return typeof n === 'string' && n.indexOf('.') !== -1 && parseFloat(n) === 1;
}
/**
 * Check to see if string passed in is a percentage
 * @hidden
 */
function isPercentage(n) {
    return typeof n === 'string' && n.indexOf('%') !== -1;
}
/**
 * Return a valid alpha value [0,1] with all invalid values being set to 1
 * @hidden
 */
function boundAlpha(a) {
    a = parseFloat(a);
    if (isNaN(a) || a < 0 || a > 1) {
        a = 1;
    }
    return a;
}
/**
 * Replace a decimal with it's percentage value
 * @hidden
 */
function convertToPercentage(n) {
    if (n <= 1) {
        return Number(n) * 100 + "%";
    }
    return n;
}
/**
 * Force a hex value to have 2 characters
 * @hidden
 */
function pad2(c) {
    return c.length === 1 ? '0' + c : String(c);
}

// `rgbToHsl`, `rgbToHsv`, `hslToRgb`, `hsvToRgb` modified from:
// <http://mjijackson.com/2008/02/rgb-to-hsl-and-rgb-to-hsv-color-model-conversion-algorithms-in-javascript>
/**
 * Handle bounds / percentage checking to conform to CSS color spec
 * <http://www.w3.org/TR/css3-color/>
 * *Assumes:* r, g, b in [0, 255] or [0, 1]
 * *Returns:* { r, g, b } in [0, 255]
 */
function rgbToRgb(r, g, b) {
    return {
        r: bound01(r, 255) * 255,
        g: bound01(g, 255) * 255,
        b: bound01(b, 255) * 255,
    };
}
function hue2rgb(p, q, t) {
    if (t < 0) {
        t += 1;
    }
    if (t > 1) {
        t -= 1;
    }
    if (t < 1 / 6) {
        return p + (q - p) * (6 * t);
    }
    if (t < 1 / 2) {
        return q;
    }
    if (t < 2 / 3) {
        return p + (q - p) * (2 / 3 - t) * 6;
    }
    return p;
}
/**
 * Converts an HSL color value to RGB.
 *
 * *Assumes:* h is contained in [0, 1] or [0, 360] and s and l are contained [0, 1] or [0, 100]
 * *Returns:* { r, g, b } in the set [0, 255]
 */
function hslToRgb(h, s, l) {
    var r;
    var g;
    var b;
    h = bound01(h, 360);
    s = bound01(s, 100);
    l = bound01(l, 100);
    if (s === 0) {
        // achromatic
        g = l;
        b = l;
        r = l;
    }
    else {
        var q = l < 0.5 ? l * (1 + s) : l + s - l * s;
        var p = 2 * l - q;
        r = hue2rgb(p, q, h + 1 / 3);
        g = hue2rgb(p, q, h);
        b = hue2rgb(p, q, h - 1 / 3);
    }
    return { r: r * 255, g: g * 255, b: b * 255 };
}
/**
 * Converts an RGB color value to HSV
 *
 * *Assumes:* r, g, and b are contained in the set [0, 255] or [0, 1]
 * *Returns:* { h, s, v } in [0,1]
 */
function rgbToHsv(r, g, b) {
    r = bound01(r, 255);
    g = bound01(g, 255);
    b = bound01(b, 255);
    var max = Math.max(r, g, b);
    var min = Math.min(r, g, b);
    var h = 0;
    var v = max;
    var d = max - min;
    var s = max === 0 ? 0 : d / max;
    if (max === min) {
        h = 0; // achromatic
    }
    else {
        switch (max) {
            case r:
                h = (g - b) / d + (g < b ? 6 : 0);
                break;
            case g:
                h = (b - r) / d + 2;
                break;
            case b:
                h = (r - g) / d + 4;
                break;
        }
        h /= 6;
    }
    return { h: h, s: s, v: v };
}
/**
 * Converts an HSV color value to RGB.
 *
 * *Assumes:* h is contained in [0, 1] or [0, 360] and s and v are contained in [0, 1] or [0, 100]
 * *Returns:* { r, g, b } in the set [0, 255]
 */
function hsvToRgb(h, s, v) {
    h = bound01(h, 360) * 6;
    s = bound01(s, 100);
    v = bound01(v, 100);
    var i = Math.floor(h);
    var f = h - i;
    var p = v * (1 - s);
    var q = v * (1 - f * s);
    var t = v * (1 - (1 - f) * s);
    var mod = i % 6;
    var r = [v, q, p, p, t, v][mod];
    var g = [t, v, v, q, p, p][mod];
    var b = [p, p, t, v, v, q][mod];
    return { r: r * 255, g: g * 255, b: b * 255 };
}
/**
 * Converts an RGB color to hex
 *
 * Assumes r, g, and b are contained in the set [0, 255]
 * Returns a 3 or 6 character hex
 */
function rgbToHex(r, g, b, allow3Char) {
    var hex = [
        pad2(Math.round(r).toString(16)),
        pad2(Math.round(g).toString(16)),
        pad2(Math.round(b).toString(16)),
    ];
    // Return a 3 character hex if possible
    if (allow3Char &&
        hex[0].startsWith(hex[0].charAt(1)) &&
        hex[1].startsWith(hex[1].charAt(1)) &&
        hex[2].startsWith(hex[2].charAt(1))) {
        return hex[0].charAt(0) + hex[1].charAt(0) + hex[2].charAt(0);
    }
    return hex.join('');
}
/** Converts a hex value to a decimal */
function convertHexToDecimal(h) {
    return parseIntFromHex(h) / 255;
}
/** Parse a base-16 hex value into a base-10 integer */
function parseIntFromHex(val) {
    return parseInt(val, 16);
}

// https://github.com/bahamas10/css-color-names/blob/master/css-color-names.json
/**
 * @hidden
 */
var names = {
    aliceblue: '#f0f8ff',
    antiquewhite: '#faebd7',
    aqua: '#00ffff',
    aquamarine: '#7fffd4',
    azure: '#f0ffff',
    beige: '#f5f5dc',
    bisque: '#ffe4c4',
    black: '#000000',
    blanchedalmond: '#ffebcd',
    blue: '#0000ff',
    blueviolet: '#8a2be2',
    brown: '#a52a2a',
    burlywood: '#deb887',
    cadetblue: '#5f9ea0',
    chartreuse: '#7fff00',
    chocolate: '#d2691e',
    coral: '#ff7f50',
    cornflowerblue: '#6495ed',
    cornsilk: '#fff8dc',
    crimson: '#dc143c',
    cyan: '#00ffff',
    darkblue: '#00008b',
    darkcyan: '#008b8b',
    darkgoldenrod: '#b8860b',
    darkgray: '#a9a9a9',
    darkgreen: '#006400',
    darkgrey: '#a9a9a9',
    darkkhaki: '#bdb76b',
    darkmagenta: '#8b008b',
    darkolivegreen: '#556b2f',
    darkorange: '#ff8c00',
    darkorchid: '#9932cc',
    darkred: '#8b0000',
    darksalmon: '#e9967a',
    darkseagreen: '#8fbc8f',
    darkslateblue: '#483d8b',
    darkslategray: '#2f4f4f',
    darkslategrey: '#2f4f4f',
    darkturquoise: '#00ced1',
    darkviolet: '#9400d3',
    deeppink: '#ff1493',
    deepskyblue: '#00bfff',
    dimgray: '#696969',
    dimgrey: '#696969',
    dodgerblue: '#1e90ff',
    firebrick: '#b22222',
    floralwhite: '#fffaf0',
    forestgreen: '#228b22',
    fuchsia: '#ff00ff',
    gainsboro: '#dcdcdc',
    ghostwhite: '#f8f8ff',
    goldenrod: '#daa520',
    gold: '#ffd700',
    gray: '#808080',
    green: '#008000',
    greenyellow: '#adff2f',
    grey: '#808080',
    honeydew: '#f0fff0',
    hotpink: '#ff69b4',
    indianred: '#cd5c5c',
    indigo: '#4b0082',
    ivory: '#fffff0',
    khaki: '#f0e68c',
    lavenderblush: '#fff0f5',
    lavender: '#e6e6fa',
    lawngreen: '#7cfc00',
    lemonchiffon: '#fffacd',
    lightblue: '#add8e6',
    lightcoral: '#f08080',
    lightcyan: '#e0ffff',
    lightgoldenrodyellow: '#fafad2',
    lightgray: '#d3d3d3',
    lightgreen: '#90ee90',
    lightgrey: '#d3d3d3',
    lightpink: '#ffb6c1',
    lightsalmon: '#ffa07a',
    lightseagreen: '#20b2aa',
    lightskyblue: '#87cefa',
    lightslategray: '#778899',
    lightslategrey: '#778899',
    lightsteelblue: '#b0c4de',
    lightyellow: '#ffffe0',
    lime: '#00ff00',
    limegreen: '#32cd32',
    linen: '#faf0e6',
    magenta: '#ff00ff',
    maroon: '#800000',
    mediumaquamarine: '#66cdaa',
    mediumblue: '#0000cd',
    mediumorchid: '#ba55d3',
    mediumpurple: '#9370db',
    mediumseagreen: '#3cb371',
    mediumslateblue: '#7b68ee',
    mediumspringgreen: '#00fa9a',
    mediumturquoise: '#48d1cc',
    mediumvioletred: '#c71585',
    midnightblue: '#191970',
    mintcream: '#f5fffa',
    mistyrose: '#ffe4e1',
    moccasin: '#ffe4b5',
    navajowhite: '#ffdead',
    navy: '#000080',
    oldlace: '#fdf5e6',
    olive: '#808000',
    olivedrab: '#6b8e23',
    orange: '#ffa500',
    orangered: '#ff4500',
    orchid: '#da70d6',
    palegoldenrod: '#eee8aa',
    palegreen: '#98fb98',
    paleturquoise: '#afeeee',
    palevioletred: '#db7093',
    papayawhip: '#ffefd5',
    peachpuff: '#ffdab9',
    peru: '#cd853f',
    pink: '#ffc0cb',
    plum: '#dda0dd',
    powderblue: '#b0e0e6',
    purple: '#800080',
    rebeccapurple: '#663399',
    red: '#ff0000',
    rosybrown: '#bc8f8f',
    royalblue: '#4169e1',
    saddlebrown: '#8b4513',
    salmon: '#fa8072',
    sandybrown: '#f4a460',
    seagreen: '#2e8b57',
    seashell: '#fff5ee',
    sienna: '#a0522d',
    silver: '#c0c0c0',
    skyblue: '#87ceeb',
    slateblue: '#6a5acd',
    slategray: '#708090',
    slategrey: '#708090',
    snow: '#fffafa',
    springgreen: '#00ff7f',
    steelblue: '#4682b4',
    tan: '#d2b48c',
    teal: '#008080',
    thistle: '#d8bfd8',
    tomato: '#ff6347',
    turquoise: '#40e0d0',
    violet: '#ee82ee',
    wheat: '#f5deb3',
    white: '#ffffff',
    whitesmoke: '#f5f5f5',
    yellow: '#ffff00',
    yellowgreen: '#9acd32',
};

/**
 * Given a string or object, convert that input to RGB
 *
 * Possible string inputs:
 * ```
 * "red"
 * "#f00" or "f00"
 * "#ff0000" or "ff0000"
 * "#ff000000" or "ff000000"
 * "rgb 255 0 0" or "rgb (255, 0, 0)"
 * "rgb 1.0 0 0" or "rgb (1, 0, 0)"
 * "rgba (255, 0, 0, 1)" or "rgba 255, 0, 0, 1"
 * "rgba (1.0, 0, 0, 1)" or "rgba 1.0, 0, 0, 1"
 * "hsl(0, 100%, 50%)" or "hsl 0 100% 50%"
 * "hsla(0, 100%, 50%, 1)" or "hsla 0 100% 50%, 1"
 * "hsv(0, 100%, 100%)" or "hsv 0 100% 100%"
 * ```
 */
function inputToRGB(color) {
    var rgb = { r: 0, g: 0, b: 0 };
    var a = 1;
    var s = null;
    var v = null;
    var l = null;
    var ok = false;
    var format = false;
    if (typeof color === 'string') {
        color = stringInputToObject(color);
    }
    if (typeof color === 'object') {
        if (isValidCSSUnit(color.r) && isValidCSSUnit(color.g) && isValidCSSUnit(color.b)) {
            rgb = rgbToRgb(color.r, color.g, color.b);
            ok = true;
            format = String(color.r).substr(-1) === '%' ? 'prgb' : 'rgb';
        }
        else if (isValidCSSUnit(color.h) && isValidCSSUnit(color.s) && isValidCSSUnit(color.v)) {
            s = convertToPercentage(color.s);
            v = convertToPercentage(color.v);
            rgb = hsvToRgb(color.h, s, v);
            ok = true;
            format = 'hsv';
        }
        else if (isValidCSSUnit(color.h) && isValidCSSUnit(color.s) && isValidCSSUnit(color.l)) {
            s = convertToPercentage(color.s);
            l = convertToPercentage(color.l);
            rgb = hslToRgb(color.h, s, l);
            ok = true;
            format = 'hsl';
        }
        if (Object.prototype.hasOwnProperty.call(color, 'a')) {
            a = color.a;
        }
    }
    a = boundAlpha(a);
    return {
        ok: ok,
        format: color.format || format,
        r: Math.min(255, Math.max(rgb.r, 0)),
        g: Math.min(255, Math.max(rgb.g, 0)),
        b: Math.min(255, Math.max(rgb.b, 0)),
        a: a,
    };
}
// <http://www.w3.org/TR/css3-values/#integers>
var CSS_INTEGER = '[-\\+]?\\d+%?';
// <http://www.w3.org/TR/css3-values/#number-value>
var CSS_NUMBER = '[-\\+]?\\d*\\.\\d+%?';
// Allow positive/negative integer/number.  Don't capture the either/or, just the entire outcome.
var CSS_UNIT = "(?:" + CSS_NUMBER + ")|(?:" + CSS_INTEGER + ")";
// Actual matching.
// Parentheses and commas are optional, but not required.
// Whitespace can take the place of commas or opening paren
var PERMISSIVE_MATCH3 = "[\\s|\\(]+(" + CSS_UNIT + ")[,|\\s]+(" + CSS_UNIT + ")[,|\\s]+(" + CSS_UNIT + ")\\s*\\)?";
var PERMISSIVE_MATCH4 = "[\\s|\\(]+(" + CSS_UNIT + ")[,|\\s]+(" + CSS_UNIT + ")[,|\\s]+(" + CSS_UNIT + ")[,|\\s]+(" + CSS_UNIT + ")\\s*\\)?";
var matchers = {
    CSS_UNIT: new RegExp(CSS_UNIT),
    rgb: new RegExp('rgb' + PERMISSIVE_MATCH3),
    rgba: new RegExp('rgba' + PERMISSIVE_MATCH4),
    hsl: new RegExp('hsl' + PERMISSIVE_MATCH3),
    hsla: new RegExp('hsla' + PERMISSIVE_MATCH4),
    hsv: new RegExp('hsv' + PERMISSIVE_MATCH3),
    hsva: new RegExp('hsva' + PERMISSIVE_MATCH4),
    hex3: /^#?([0-9a-fA-F]{1})([0-9a-fA-F]{1})([0-9a-fA-F]{1})$/,
    hex6: /^#?([0-9a-fA-F]{2})([0-9a-fA-F]{2})([0-9a-fA-F]{2})$/,
    hex4: /^#?([0-9a-fA-F]{1})([0-9a-fA-F]{1})([0-9a-fA-F]{1})([0-9a-fA-F]{1})$/,
    hex8: /^#?([0-9a-fA-F]{2})([0-9a-fA-F]{2})([0-9a-fA-F]{2})([0-9a-fA-F]{2})$/,
};
/**
 * Permissive string parsing.  Take in a number of formats, and output an object
 * based on detected format.  Returns `{ r, g, b }` or `{ h, s, l }` or `{ h, s, v}`
 */
function stringInputToObject(color) {
    color = color.trim().toLowerCase();
    if (color.length === 0) {
        return false;
    }
    var named = false;
    if (names[color]) {
        color = names[color];
        named = true;
    }
    else if (color === 'transparent') {
        return { r: 0, g: 0, b: 0, a: 0, format: 'name' };
    }
    // Try to match string input using regular expressions.
    // Keep most of the number bounding out of this function - don't worry about [0,1] or [0,100] or [0,360]
    // Just return an object and let the conversion functions handle that.
    // This way the result will be the same whether the tinycolor is initialized with string or object.
    var match = matchers.rgb.exec(color);
    if (match) {
        return { r: match[1], g: match[2], b: match[3] };
    }
    match = matchers.rgba.exec(color);
    if (match) {
        return { r: match[1], g: match[2], b: match[3], a: match[4] };
    }
    match = matchers.hsl.exec(color);
    if (match) {
        return { h: match[1], s: match[2], l: match[3] };
    }
    match = matchers.hsla.exec(color);
    if (match) {
        return { h: match[1], s: match[2], l: match[3], a: match[4] };
    }
    match = matchers.hsv.exec(color);
    if (match) {
        return { h: match[1], s: match[2], v: match[3] };
    }
    match = matchers.hsva.exec(color);
    if (match) {
        return { h: match[1], s: match[2], v: match[3], a: match[4] };
    }
    match = matchers.hex8.exec(color);
    if (match) {
        return {
            r: parseIntFromHex(match[1]),
            g: parseIntFromHex(match[2]),
            b: parseIntFromHex(match[3]),
            a: convertHexToDecimal(match[4]),
            format: named ? 'name' : 'hex8',
        };
    }
    match = matchers.hex6.exec(color);
    if (match) {
        return {
            r: parseIntFromHex(match[1]),
            g: parseIntFromHex(match[2]),
            b: parseIntFromHex(match[3]),
            format: named ? 'name' : 'hex',
        };
    }
    match = matchers.hex4.exec(color);
    if (match) {
        return {
            r: parseIntFromHex(match[1] + match[1]),
            g: parseIntFromHex(match[2] + match[2]),
            b: parseIntFromHex(match[3] + match[3]),
            a: convertHexToDecimal(match[4] + match[4]),
            format: named ? 'name' : 'hex8',
        };
    }
    match = matchers.hex3.exec(color);
    if (match) {
        return {
            r: parseIntFromHex(match[1] + match[1]),
            g: parseIntFromHex(match[2] + match[2]),
            b: parseIntFromHex(match[3] + match[3]),
            format: named ? 'name' : 'hex',
        };
    }
    return false;
}
/**
 * Check to see if it looks like a CSS unit
 * (see `matchers` above for definition).
 */
function isValidCSSUnit(color) {
    return Boolean(matchers.CSS_UNIT.exec(String(color)));
}

var hueStep = 2; // 色相阶梯

var saturationStep = 0.16; // 饱和度阶梯，浅色部分

var saturationStep2 = 0.05; // 饱和度阶梯，深色部分

var brightnessStep1 = 0.05; // 亮度阶梯，浅色部分

var brightnessStep2 = 0.15; // 亮度阶梯，深色部分

var lightColorCount = 5; // 浅色数量，主色上

var darkColorCount = 4; // 深色数量，主色下
// 暗色主题颜色映射关系表

var darkColorMap = [{
  index: 7,
  opacity: 0.15
}, {
  index: 6,
  opacity: 0.25
}, {
  index: 5,
  opacity: 0.3
}, {
  index: 5,
  opacity: 0.45
}, {
  index: 5,
  opacity: 0.65
}, {
  index: 5,
  opacity: 0.85
}, {
  index: 4,
  opacity: 0.9
}, {
  index: 3,
  opacity: 0.95
}, {
  index: 2,
  opacity: 0.97
}, {
  index: 1,
  opacity: 0.98
}]; // Wrapper function ported from TinyColor.prototype.toHsv
// Keep it here because of `hsv.h * 360`

function toHsv(_ref) {
  var r = _ref.r,
      g = _ref.g,
      b = _ref.b;
  var hsv = rgbToHsv(r, g, b);
  return {
    h: hsv.h * 360,
    s: hsv.s,
    v: hsv.v
  };
} // Wrapper function ported from TinyColor.prototype.toHexString
// Keep it here because of the prefix `#`


function toHex(_ref2) {
  var r = _ref2.r,
      g = _ref2.g,
      b = _ref2.b;
  return "#".concat(rgbToHex(r, g, b, false));
} // Wrapper function ported from TinyColor.prototype.mix, not treeshakable.
// Amount in range [0, 1]
// Assume color1 & color2 has no alpha, since the following src code did so.


function mix(rgb1, rgb2, amount) {
  var p = amount / 100;
  var rgb = {
    r: (rgb2.r - rgb1.r) * p + rgb1.r,
    g: (rgb2.g - rgb1.g) * p + rgb1.g,
    b: (rgb2.b - rgb1.b) * p + rgb1.b
  };
  return rgb;
}

function getHue(hsv, i, light) {
  var hue; // 根据色相不同，色相转向不同

  if (Math.round(hsv.h) >= 60 && Math.round(hsv.h) <= 240) {
    hue = light ? Math.round(hsv.h) - hueStep * i : Math.round(hsv.h) + hueStep * i;
  } else {
    hue = light ? Math.round(hsv.h) + hueStep * i : Math.round(hsv.h) - hueStep * i;
  }

  if (hue < 0) {
    hue += 360;
  } else if (hue >= 360) {
    hue -= 360;
  }

  return hue;
}

function getSaturation(hsv, i, light) {
  // grey color don't change saturation
  if (hsv.h === 0 && hsv.s === 0) {
    return hsv.s;
  }

  var saturation;

  if (light) {
    saturation = hsv.s - saturationStep * i;
  } else if (i === darkColorCount) {
    saturation = hsv.s + saturationStep;
  } else {
    saturation = hsv.s + saturationStep2 * i;
  } // 边界值修正


  if (saturation > 1) {
    saturation = 1;
  } // 第一格的 s 限制在 0.06-0.1 之间


  if (light && i === lightColorCount && saturation > 0.1) {
    saturation = 0.1;
  }

  if (saturation < 0.06) {
    saturation = 0.06;
  }

  return Number(saturation.toFixed(2));
}

function getValue(hsv, i, light) {
  var value;

  if (light) {
    value = hsv.v + brightnessStep1 * i;
  } else {
    value = hsv.v - brightnessStep2 * i;
  }

  if (value > 1) {
    value = 1;
  }

  return Number(value.toFixed(2));
}

function generate(color) {
  var opts = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
  var patterns = [];
  var pColor = inputToRGB(color);

  for (var i = lightColorCount; i > 0; i -= 1) {
    var hsv = toHsv(pColor);
    var colorString = toHex(inputToRGB({
      h: getHue(hsv, i, true),
      s: getSaturation(hsv, i, true),
      v: getValue(hsv, i, true)
    }));
    patterns.push(colorString);
  }

  patterns.push(toHex(pColor));

  for (var _i = 1; _i <= darkColorCount; _i += 1) {
    var _hsv = toHsv(pColor);

    var _colorString = toHex(inputToRGB({
      h: getHue(_hsv, _i),
      s: getSaturation(_hsv, _i),
      v: getValue(_hsv, _i)
    }));

    patterns.push(_colorString);
  } // dark theme patterns


  if (opts.theme === 'dark') {
    return darkColorMap.map(function (_ref3) {
      var index = _ref3.index,
          opacity = _ref3.opacity;
      var darkColorString = toHex(mix(inputToRGB(opts.backgroundColor || '#141414'), inputToRGB(patterns[index]), opacity * 100));
      return darkColorString;
    });
  }

  return patterns;
}

var presetPrimaryColors = {
  red: '#F5222D',
  volcano: '#FA541C',
  orange: '#FA8C16',
  gold: '#FAAD14',
  yellow: '#FADB14',
  lime: '#A0D911',
  green: '#52C41A',
  cyan: '#13C2C2',
  blue: '#1890FF',
  geekblue: '#2F54EB',
  purple: '#722ED1',
  magenta: '#EB2F96',
  grey: '#666666'
};
var presetPalettes = {};
var presetDarkPalettes = {};
Object.keys(presetPrimaryColors).forEach(function (key) {
  presetPalettes[key] = generate(presetPrimaryColors[key]);
  presetPalettes[key].primary = presetPalettes[key][5]; // dark presetPalettes

  presetDarkPalettes[key] = generate(presetPrimaryColors[key], {
    theme: 'dark',
    backgroundColor: '#141414'
  });
  presetDarkPalettes[key].primary = presetDarkPalettes[key][5];
});

/* eslint-disable no-console */
var warned = {};
function warning(valid, message) {
  // Support uglify
  if (process.env.NODE_ENV !== 'production' && !valid && console !== undefined) {
    console.error("Warning: ".concat(message));
  }
}
function call(method, valid, message) {
  if (!valid && !warned[message]) {
    method(false, message);
    warned[message] = true;
  }
}
function warningOnce(valid, message) {
  call(warning, valid, message);
}
/* eslint-enable */

function canUseDom() {
  return !!(typeof window !== 'undefined' && window.document && window.document.createElement);
}

var MARK_KEY = "rc-util-key";

function getMark() {
  var _ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
      mark = _ref.mark;

  if (mark) {
    return mark.startsWith('data-') ? mark : "data-".concat(mark);
  }

  return MARK_KEY;
}

function getContainer(option) {
  if (option.attachTo) {
    return option.attachTo;
  }

  var head = document.querySelector('head');
  return head || document.body;
}

function injectCSS(css) {
  var _option$csp;

  var option = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

  if (!canUseDom()) {
    return null;
  }

  var styleNode = document.createElement('style');

  if ((_option$csp = option.csp) === null || _option$csp === void 0 ? void 0 : _option$csp.nonce) {
    var _option$csp2;

    styleNode.nonce = (_option$csp2 = option.csp) === null || _option$csp2 === void 0 ? void 0 : _option$csp2.nonce;
  }

  styleNode.innerHTML = css;
  var container = getContainer(option);
  var firstChild = container.firstChild;

  if (option.prepend && container.prepend) {
    // Use `prepend` first
    container.prepend(styleNode);
  } else if (option.prepend && firstChild) {
    // Fallback to `insertBefore` like IE not support `prepend`
    container.insertBefore(styleNode, firstChild);
  } else {
    container.appendChild(styleNode);
  }

  return styleNode;
}
var containerCache = new Map();

function findExistNode(key) {
  var option = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
  var container = getContainer(option);
  return Array.from(containerCache.get(container).children).find(function (node) {
    return node.tagName === 'STYLE' && node.getAttribute(getMark(option)) === key;
  });
}
function updateCSS(css, key) {
  var option = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};
  var container = getContainer(option); // Get real parent

  if (!containerCache.has(container)) {
    var placeholderStyle = injectCSS('', option);
    var parentNode = placeholderStyle.parentNode;
    containerCache.set(container, parentNode);
    parentNode.removeChild(placeholderStyle);
  }

  var existNode = findExistNode(key, option);

  if (existNode) {
    var _option$csp3, _option$csp4;

    if (((_option$csp3 = option.csp) === null || _option$csp3 === void 0 ? void 0 : _option$csp3.nonce) && existNode.nonce !== ((_option$csp4 = option.csp) === null || _option$csp4 === void 0 ? void 0 : _option$csp4.nonce)) {
      var _option$csp5;

      existNode.nonce = (_option$csp5 = option.csp) === null || _option$csp5 === void 0 ? void 0 : _option$csp5.nonce;
    }

    if (existNode.innerHTML !== css) {
      existNode.innerHTML = css;
    }

    return existNode;
  }

  var newNode = injectCSS(css, option);
  newNode.setAttribute(getMark(option), key);
  return newNode;
}

function warning$1(valid, message) {
  warningOnce(valid, "[@ant-design/icons] ".concat(message));
}
function isIconDefinition(target) {
  return _typeof$1(target) === 'object' && typeof target.name === 'string' && typeof target.theme === 'string' && (_typeof$1(target.icon) === 'object' || typeof target.icon === 'function');
}
function normalizeAttrs() {
  var attrs = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  return Object.keys(attrs).reduce(function (acc, key) {
    var val = attrs[key];

    switch (key) {
      case 'class':
        acc.className = val;
        delete acc.class;
        break;

      default:
        acc[key] = val;
    }

    return acc;
  }, {});
}
function generate$1(node, key, rootProps) {
  if (!rootProps) {
    return /*#__PURE__*/React.createElement(node.tag, _objectSpread2$1({
      key: key
    }, normalizeAttrs(node.attrs)), (node.children || []).map(function (child, index) {
      return generate$1(child, "".concat(key, "-").concat(node.tag, "-").concat(index));
    }));
  }

  return /*#__PURE__*/React.createElement(node.tag, _objectSpread2$1(_objectSpread2$1({
    key: key
  }, normalizeAttrs(node.attrs)), rootProps), (node.children || []).map(function (child, index) {
    return generate$1(child, "".concat(key, "-").concat(node.tag, "-").concat(index));
  }));
}
function getSecondaryColor(primaryColor) {
  // choose the second color
  return generate(primaryColor)[0];
}
function normalizeTwoToneColors(twoToneColor) {
  if (!twoToneColor) {
    return [];
  }

  return Array.isArray(twoToneColor) ? twoToneColor : [twoToneColor];
} // These props make sure that the SVG behaviours like general text.
// Reference: https://blog.prototypr.io/align-svg-icons-to-text-and-say-goodbye-to-font-icons-d44b3d7b26b4

var svgBaseProps = {
  width: '1em',
  height: '1em',
  fill: 'currentColor',
  'aria-hidden': 'true',
  focusable: 'false'
};
var iconStyles = "\n.anticon {\n  display: inline-block;\n  color: inherit;\n  font-style: normal;\n  line-height: 0;\n  text-align: center;\n  text-transform: none;\n  vertical-align: -0.125em;\n  text-rendering: optimizeLegibility;\n  -webkit-font-smoothing: antialiased;\n  -moz-osx-font-smoothing: grayscale;\n}\n\n.anticon > * {\n  line-height: 1;\n}\n\n.anticon svg {\n  display: inline-block;\n}\n\n.anticon::before {\n  display: none;\n}\n\n.anticon .anticon-icon {\n  display: block;\n}\n\n.anticon[tabindex] {\n  cursor: pointer;\n}\n\n.anticon-spin::before,\n.anticon-spin {\n  display: inline-block;\n  -webkit-animation: loadingCircle 1s infinite linear;\n  animation: loadingCircle 1s infinite linear;\n}\n\n@-webkit-keyframes loadingCircle {\n  100% {\n    -webkit-transform: rotate(360deg);\n    transform: rotate(360deg);\n  }\n}\n\n@keyframes loadingCircle {\n  100% {\n    -webkit-transform: rotate(360deg);\n    transform: rotate(360deg);\n  }\n}\n";
var useInsertStyles = function useInsertStyles() {
  var styleStr = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : iconStyles;

  var _useContext = useContext(IconContext),
      csp = _useContext.csp;

  useEffect(function () {
    updateCSS(styleStr, '@ant-design-icons', {
      prepend: true,
      csp: csp
    });
  }, []);
};

var _excluded = ["icon", "className", "onClick", "style", "primaryColor", "secondaryColor"];
var twoToneColorPalette = {
  primaryColor: '#333',
  secondaryColor: '#E6E6E6',
  calculated: false
};

function setTwoToneColors(_ref) {
  var primaryColor = _ref.primaryColor,
      secondaryColor = _ref.secondaryColor;
  twoToneColorPalette.primaryColor = primaryColor;
  twoToneColorPalette.secondaryColor = secondaryColor || getSecondaryColor(primaryColor);
  twoToneColorPalette.calculated = !!secondaryColor;
}

function getTwoToneColors() {
  return _objectSpread2$1({}, twoToneColorPalette);
}

var IconBase = function IconBase(props) {
  var icon = props.icon,
      className = props.className,
      onClick = props.onClick,
      style = props.style,
      primaryColor = props.primaryColor,
      secondaryColor = props.secondaryColor,
      restProps = _objectWithoutProperties$1(props, _excluded);

  var colors = twoToneColorPalette;

  if (primaryColor) {
    colors = {
      primaryColor: primaryColor,
      secondaryColor: secondaryColor || getSecondaryColor(primaryColor)
    };
  }

  useInsertStyles();
  warning$1(isIconDefinition(icon), "icon should be icon definiton, but got ".concat(icon));

  if (!isIconDefinition(icon)) {
    return null;
  }

  var target = icon;

  if (target && typeof target.icon === 'function') {
    target = _objectSpread2$1(_objectSpread2$1({}, target), {}, {
      icon: target.icon(colors.primaryColor, colors.secondaryColor)
    });
  }

  return generate$1(target.icon, "svg-".concat(target.name), _objectSpread2$1({
    className: className,
    onClick: onClick,
    style: style,
    'data-icon': target.name,
    width: '1em',
    height: '1em',
    fill: 'currentColor',
    'aria-hidden': 'true'
  }, restProps));
};

IconBase.displayName = 'IconReact';
IconBase.getTwoToneColors = getTwoToneColors;
IconBase.setTwoToneColors = setTwoToneColors;

function setTwoToneColor(twoToneColor) {
  var _normalizeTwoToneColo = normalizeTwoToneColors(twoToneColor),
      _normalizeTwoToneColo2 = _slicedToArray$1(_normalizeTwoToneColo, 2),
      primaryColor = _normalizeTwoToneColo2[0],
      secondaryColor = _normalizeTwoToneColo2[1];

  return IconBase.setTwoToneColors({
    primaryColor: primaryColor,
    secondaryColor: secondaryColor
  });
}
function getTwoToneColor() {
  var colors = IconBase.getTwoToneColors();

  if (!colors.calculated) {
    return colors.primaryColor;
  }

  return [colors.primaryColor, colors.secondaryColor];
}

var _excluded$1 = ["className", "icon", "spin", "rotate", "tabIndex", "onClick", "twoToneColor"];
// should move it to antd main repo?

setTwoToneColor('#1890ff');
var Icon = /*#__PURE__*/forwardRef(function (props, ref) {
  var _classNames;

  var className = props.className,
      icon = props.icon,
      spin = props.spin,
      rotate = props.rotate,
      tabIndex = props.tabIndex,
      onClick = props.onClick,
      twoToneColor = props.twoToneColor,
      restProps = _objectWithoutProperties$1(props, _excluded$1);

  var _React$useContext = useContext(IconContext),
      _React$useContext$pre = _React$useContext.prefixCls,
      prefixCls = _React$useContext$pre === void 0 ? 'anticon' : _React$useContext$pre;

  var classString = classnames(prefixCls, (_classNames = {}, _defineProperty$1(_classNames, "".concat(prefixCls, "-").concat(icon.name), !!icon.name), _defineProperty$1(_classNames, "".concat(prefixCls, "-spin"), !!spin || icon.name === 'loading'), _classNames), className);
  var iconTabIndex = tabIndex;

  if (iconTabIndex === undefined && onClick) {
    iconTabIndex = -1;
  }

  var svgStyle = rotate ? {
    msTransform: "rotate(".concat(rotate, "deg)"),
    transform: "rotate(".concat(rotate, "deg)")
  } : undefined;

  var _normalizeTwoToneColo = normalizeTwoToneColors(twoToneColor),
      _normalizeTwoToneColo2 = _slicedToArray$1(_normalizeTwoToneColo, 2),
      primaryColor = _normalizeTwoToneColo2[0],
      secondaryColor = _normalizeTwoToneColo2[1];

  return /*#__PURE__*/createElement("span", _objectSpread2$1(_objectSpread2$1({
    role: "img",
    "aria-label": icon.name
  }, restProps), {}, {
    ref: ref,
    tabIndex: iconTabIndex,
    onClick: onClick,
    className: classString
  }), /*#__PURE__*/createElement(IconBase, {
    icon: icon,
    primaryColor: primaryColor,
    secondaryColor: secondaryColor,
    style: svgStyle
  }));
});
Icon.displayName = 'AntdIcon';
Icon.getTwoToneColor = getTwoToneColor;
Icon.setTwoToneColor = setTwoToneColor;

// This icon file is generated automatically.
var DownOutlined = { "icon": { "tag": "svg", "attrs": { "viewBox": "64 64 896 896", "focusable": "false" }, "children": [{ "tag": "path", "attrs": { "d": "M884 256h-75c-5.1 0-9.9 2.5-12.9 6.6L512 654.2 227.9 262.6c-3-4.1-7.8-6.6-12.9-6.6h-75c-6.5 0-10.3 7.4-6.5 12.7l352.6 486.1c12.8 17.6 39 17.6 51.7 0l352.6-486.1c3.9-5.3.1-12.7-6.4-12.7z" } }] }, "name": "down", "theme": "outlined" };

var DownOutlined$1 = function DownOutlined$1(props, ref) {
  return /*#__PURE__*/createElement(Icon, _objectSpread2$1(_objectSpread2$1({}, props), {}, {
    ref: ref,
    icon: DownOutlined
  }));
};

DownOutlined$1.displayName = 'DownOutlined';
var DownOutlined$2 = /*#__PURE__*/forwardRef(DownOutlined$1);

// This icon file is generated automatically.
var UpOutlined = { "icon": { "tag": "svg", "attrs": { "viewBox": "64 64 896 896", "focusable": "false" }, "children": [{ "tag": "path", "attrs": { "d": "M890.5 755.3L537.9 269.2c-12.8-17.6-39-17.6-51.7 0L133.5 755.3A8 8 0 00140 768h75c5.1 0 9.9-2.5 12.9-6.6L512 369.8l284.1 391.6c3 4.1 7.8 6.6 12.9 6.6h75c6.5 0 10.3-7.4 6.5-12.7z" } }] }, "name": "up", "theme": "outlined" };

var UpOutlined$1 = function UpOutlined$1(props, ref) {
  return /*#__PURE__*/createElement(Icon, _objectSpread2$1(_objectSpread2$1({}, props), {}, {
    ref: ref,
    icon: UpOutlined
  }));
};

UpOutlined$1.displayName = 'UpOutlined';
var UpOutlined$2 = /*#__PURE__*/forwardRef(UpOutlined$1);

var _excluded$2 = ["className", "component", "viewBox", "spin", "rotate", "tabIndex", "onClick", "children"];
var Icon$1 = /*#__PURE__*/forwardRef(function (props, ref) {
  var className = props.className,
      Component = props.component,
      viewBox = props.viewBox,
      spin = props.spin,
      rotate = props.rotate,
      tabIndex = props.tabIndex,
      onClick = props.onClick,
      children = props.children,
      restProps = _objectWithoutProperties$1(props, _excluded$2);

  warning$1(Boolean(Component || children), 'Should have `component` prop or `children`.');
  useInsertStyles();

  var _React$useContext = useContext(IconContext),
      _React$useContext$pre = _React$useContext.prefixCls,
      prefixCls = _React$useContext$pre === void 0 ? 'anticon' : _React$useContext$pre;

  var classString = classnames(prefixCls, className);
  var svgClassString = classnames(_defineProperty$1({}, "".concat(prefixCls, "-spin"), !!spin));
  var svgStyle = rotate ? {
    msTransform: "rotate(".concat(rotate, "deg)"),
    transform: "rotate(".concat(rotate, "deg)")
  } : undefined;

  var innerSvgProps = _objectSpread2$1(_objectSpread2$1({}, svgBaseProps), {}, {
    className: svgClassString,
    style: svgStyle,
    viewBox: viewBox
  });

  if (!viewBox) {
    delete innerSvgProps.viewBox;
  } // component > children


  var renderInnerNode = function renderInnerNode() {
    if (Component) {
      return /*#__PURE__*/createElement(Component, _objectSpread2$1({}, innerSvgProps), children);
    }

    if (children) {
      warning$1(Boolean(viewBox) || Children.count(children) === 1 && /*#__PURE__*/isValidElement(children) && Children.only(children).type === 'use', 'Make sure that you provide correct `viewBox`' + ' prop (default `0 0 1024 1024`) to the icon.');
      return /*#__PURE__*/createElement("svg", _objectSpread2$1(_objectSpread2$1({}, innerSvgProps), {}, {
        viewBox: viewBox
      }), children);
    }

    return null;
  };

  var iconTabIndex = tabIndex;

  if (iconTabIndex === undefined && onClick) {
    iconTabIndex = -1;
  }

  return /*#__PURE__*/createElement("span", _objectSpread2$1(_objectSpread2$1({
    role: "img"
  }, restProps), {}, {
    ref: ref,
    tabIndex: iconTabIndex,
    onClick: onClick,
    className: classString
  }), renderInnerNode());
});
Icon$1.displayName = 'AntdIcon';

var _excluded$3 = ["type", "children"];
var customCache = new Set();

function isValidCustomScriptUrl(scriptUrl) {
  return Boolean(typeof scriptUrl === 'string' && scriptUrl.length && !customCache.has(scriptUrl));
}

function createScriptUrlElements(scriptUrls) {
  var index = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 0;
  var currentScriptUrl = scriptUrls[index];

  if (isValidCustomScriptUrl(currentScriptUrl)) {
    var script = document.createElement('script');
    script.setAttribute('src', currentScriptUrl);
    script.setAttribute('data-namespace', currentScriptUrl);

    if (scriptUrls.length > index + 1) {
      script.onload = function () {
        createScriptUrlElements(scriptUrls, index + 1);
      };

      script.onerror = function () {
        createScriptUrlElements(scriptUrls, index + 1);
      };
    }

    customCache.add(currentScriptUrl);
    document.body.appendChild(script);
  }
}

function create() {
  var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  var scriptUrl = options.scriptUrl,
      _options$extraCommonP = options.extraCommonProps,
      extraCommonProps = _options$extraCommonP === void 0 ? {} : _options$extraCommonP;
  /**
   * DOM API required.
   * Make sure in browser environment.
   * The Custom Icon will create a <script/>
   * that loads SVG symbols and insert the SVG Element into the document body.
   */

  if (scriptUrl && typeof document !== 'undefined' && typeof window !== 'undefined' && typeof document.createElement === 'function') {
    if (Array.isArray(scriptUrl)) {
      // 因为iconfont资源会把svg插入before，所以前加载相同type会覆盖后加载，为了数组覆盖顺序，倒叙插入
      createScriptUrlElements(scriptUrl.reverse());
    } else {
      createScriptUrlElements([scriptUrl]);
    }
  }

  var Iconfont = /*#__PURE__*/forwardRef(function (props, ref) {
    var type = props.type,
        children = props.children,
        restProps = _objectWithoutProperties$1(props, _excluded$3); // children > type


    var content = null;

    if (props.type) {
      content = /*#__PURE__*/createElement("use", {
        xlinkHref: "#".concat(type)
      });
    }

    if (children) {
      content = children;
    }

    return /*#__PURE__*/createElement(Icon$1, _objectSpread2$1(_objectSpread2$1(_objectSpread2$1({}, extraCommonProps), restProps), {}, {
      ref: ref
    }), content);
  });
  Iconfont.displayName = 'Iconfont';
  return Iconfont;
}

var IconFont = create({
  scriptUrl: ['//at.alicdn.com/t/font_2601113_v4hbrtqz9s.js']
});
function Icon$2(props) {
  return /*#__PURE__*/React.createElement(IconFont, _objectSpread2({}, props));
}

var css_248z$1 = "/* 字体 */\n/* 行高 */\n@import '~antd/dist/antd.css';\n.ellipsis {\n  position: relative;\n  padding: 0;\n  width: 100%;\n  text-align: left;\n  background: #ffffff;\n  line-height: 1.5;\n}\n.ellipsis-hidden {\n  position: absolute;\n  top: 0;\n  left: 0;\n  opacity: 0;\n  visibility: hidden;\n}\n.ellipsis-container {\n  display: flex;\n  overflow: hidden;\n  text-overflow: ellipsis;\n  box-orient: vertical;\n  /* stylelint-disable-next-line */\n  display: -webkit-box;\n  /* stylelint-disable-next-line */\n  -webkit-box-orient: vertical;\n}\n.ellipsis .rows-1 {\n  -webkit-line-clamp: 1;\n}\n.ellipsis .rows-2 {\n  -webkit-line-clamp: 2;\n}\n.ellipsis .rows-3 {\n  -webkit-line-clamp: 3;\n}\n.ellipsis .rows-4 {\n  -webkit-line-clamp: 4;\n}\n.ellipsis .rows-5 {\n  -webkit-line-clamp: 5;\n}\n.ellipsis .rows-6 {\n  -webkit-line-clamp: 6;\n}\n.ellipsis .rows-7 {\n  -webkit-line-clamp: 7;\n}\n.ellipsis .rows-8 {\n  -webkit-line-clamp: 8;\n}\n.ellipsis .rows-9 {\n  -webkit-line-clamp: 9;\n}\n.ellipsis .rows-10 {\n  -webkit-line-clamp: 10;\n}\n.ellipsis .rows-11 {\n  -webkit-line-clamp: 11;\n}\n.ellipsis .rows-12 {\n  -webkit-line-clamp: 12;\n}\n.ellipsis .rows-13 {\n  -webkit-line-clamp: 13;\n}\n.ellipsis .rows-14 {\n  -webkit-line-clamp: 14;\n}\n.ellipsis .rows-15 {\n  -webkit-line-clamp: 15;\n}\n.ellipsis .rows-16 {\n  -webkit-line-clamp: 16;\n}\n.ellipsis .rows-17 {\n  -webkit-line-clamp: 17;\n}\n.ellipsis .rows-18 {\n  -webkit-line-clamp: 18;\n}\n.ellipsis .rows-19 {\n  -webkit-line-clamp: 19;\n}\n.ellipsis .rows-20 {\n  -webkit-line-clamp: 20;\n}\n.ellipsis .rows-21 {\n  -webkit-line-clamp: 21;\n}\n.ellipsis .rows-22 {\n  -webkit-line-clamp: 22;\n}\n.ellipsis .rows-23 {\n  -webkit-line-clamp: 23;\n}\n.ellipsis .rows-24 {\n  -webkit-line-clamp: 24;\n}\n.ellipsis .rows-25 {\n  -webkit-line-clamp: 25;\n}\n.ellipsis .rows-26 {\n  -webkit-line-clamp: 26;\n}\n.ellipsis .rows-27 {\n  -webkit-line-clamp: 27;\n}\n.ellipsis .rows-28 {\n  -webkit-line-clamp: 28;\n}\n.ellipsis .rows-29 {\n  -webkit-line-clamp: 29;\n}\n.ellipsis .rows-30 {\n  -webkit-line-clamp: 30;\n}\n.ellipsis .rows-1 {\n  -webkit-line-clamp: 1;\n}\n.ellipsis .rows-2 {\n  -webkit-line-clamp: 2;\n}\n.ellipsis .rows-3 {\n  -webkit-line-clamp: 3;\n}\n.ellipsis .rows-4 {\n  -webkit-line-clamp: 4;\n}\n.ellipsis .rows-5 {\n  -webkit-line-clamp: 5;\n}\n.ellipsis .rows-6 {\n  -webkit-line-clamp: 6;\n}\n.ellipsis .rows-7 {\n  -webkit-line-clamp: 7;\n}\n.ellipsis .rows-8 {\n  -webkit-line-clamp: 8;\n}\n.ellipsis .rows-9 {\n  -webkit-line-clamp: 9;\n}\n.ellipsis .rows-10 {\n  -webkit-line-clamp: 10;\n}\n.ellipsis .rows-11 {\n  -webkit-line-clamp: 11;\n}\n.ellipsis .rows-12 {\n  -webkit-line-clamp: 12;\n}\n.ellipsis .rows-13 {\n  -webkit-line-clamp: 13;\n}\n.ellipsis .rows-14 {\n  -webkit-line-clamp: 14;\n}\n.ellipsis .rows-15 {\n  -webkit-line-clamp: 15;\n}\n.ellipsis .rows-16 {\n  -webkit-line-clamp: 16;\n}\n.ellipsis .rows-17 {\n  -webkit-line-clamp: 17;\n}\n.ellipsis .rows-18 {\n  -webkit-line-clamp: 18;\n}\n.ellipsis .rows-19 {\n  -webkit-line-clamp: 19;\n}\n.ellipsis .rows-20 {\n  -webkit-line-clamp: 20;\n}\n.ellipsis-more {\n  position: absolute;\n  right: 0;\n  bottom: 0;\n  display: flex;\n  background: inherit;\n  line-height: normal;\n}\n.ellipsis-more div {\n  padding: 0 4px;\n  cursor: pointer;\n  color: #a9a9b9;\n}\n";
styleInject(css_248z$1);

var EllipsisLine = function EllipsisLine(props) {
  var content = props.content,
      _props$row = props.row,
      row = _props$row === void 0 ? 2 : _props$row,
      _props$text = props.text,
      text = _props$text === void 0 ? {
    expend: '【查看全部】',
    close: '【收起】'
  } : _props$text,
      ellipsisText = props.ellipsisText;

  var _useState = useState(false),
      _useState2 = _slicedToArray(_useState, 2),
      visible = _useState2[0],
      setVisible = _useState2[1]; // 是否需要展开更多


  var _useState3 = useState(false),
      _useState4 = _slicedToArray(_useState3, 2),
      isMore = _useState4[0],
      setIsMore = _useState4[1];

  var longRef = useRef(null);
  var shortRef = useRef(null);
  useEffect(function () {
    var _ref = (shortRef === null || shortRef === void 0 ? void 0 : shortRef.current) || {
      clientHeight: 0
    },
        shortHeight = _ref.clientHeight;

    var _ref2 = (longRef === null || longRef === void 0 ? void 0 : longRef.current) || {
      clientHeight: 0
    },
        longHeight = _ref2.clientHeight;

    if (longHeight > shortHeight) {
      setIsMore(true);
    }
  }, [content]);
  return /*#__PURE__*/React.createElement("div", {
    className: css_248z$1.ellipsis
  }, /*#__PURE__*/React.createElement("div", {
    className: classnames(css_248z$1['ellipsis-container'], css_248z$1["rows-".concat(!visible && row)]),
    ref: shortRef
  }, content), /*#__PURE__*/React.createElement("div", {
    ref: longRef,
    className: css_248z$1['ellipsis-hidden']
  }, content), isMore && /*#__PURE__*/React.createElement("div", {
    className: css_248z$1['ellipsis-more'],
    onClick: function onClick() {
      return setVisible(!visible);
    }
  }, visible ? /*#__PURE__*/React.createElement("div", null, text.close) : /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement("span", null, ellipsisText), /*#__PURE__*/React.createElement("div", null, text.expend))));
};

var _excluded$4 = ["options"];
var Option = Select$1.Option;

var Select = function Select(_ref) {
  var options = _ref.options,
      rest = _objectWithoutProperties(_ref, _excluded$4);

  return /*#__PURE__*/React.createElement(Select$1, _objectSpread2(_objectSpread2({}, rest), {}, {
    allowClear: true
  }), Array.from(options).map(function (option) {
    return /*#__PURE__*/React.createElement(Option, {
      value: option[0],
      key: option[0]
    }, option[1]);
  }));
};

var TreeSelect = function TreeSelect(props) {
  return /*#__PURE__*/React.createElement(TreeSelect$1, _objectSpread2({
    allowClear: true
  }, props));
};

var Input = function Input(props) {
  return /*#__PURE__*/React.createElement(Input$1, _objectSpread2({
    autoComplete: "off",
    allowClear: true
  }, props));
};

var DatePicker = function DatePicker(props) {
  return /*#__PURE__*/React.createElement(DatePicker$1, _objectSpread2({}, props));
};

var RangePicker = DatePicker$1.RangePicker;

var DateRangePicker = function DateRangePicker(props) {
  return /*#__PURE__*/React.createElement(RangePicker, _objectSpread2({}, props));
};

var Cascader = function Cascader(props) {
  return /*#__PURE__*/React.createElement(Cascader$1, _objectSpread2({}, props));
};

var css_248z$2 = ".iLab-filter-form-col .ant-form-item-label {\n  padding-bottom: 16px;\n}\n.iLab-filter-form-col .ant-form-item-label > label {\n  font-family: PingFangSC-Regular;\n  font-size: 16px;\n  line-height: 16px;\n  color: #333;\n}\n.iLab-filter-form .ant-form-item {\n  margin-bottom: 16px;\n}\n";
styleInject(css_248z$2);

var _excluded$5 = ["valueType", "valueEnum", "fieldProps"];

var FilterForm = function FilterForm(props, parentRef) {
  var className = props.className,
      style = props.style,
      _props$column = props.column,
      column = _props$column === void 0 ? 2 : _props$column,
      formProps = props.formProps,
      rowProps = props.rowProps,
      colProps = props.colProps,
      _props$options = props.options,
      options = _props$options === void 0 ? [] : _props$options,
      renderCustomAction = props.renderCustomAction,
      onSearch = props.onSearch,
      onReset = props.onReset,
      _props$showAction = props.showAction,
      showAction = _props$showAction === void 0 ? false : _props$showAction;

  var _Form$useForm = Form.useForm(),
      _Form$useForm2 = _slicedToArray(_Form$useForm, 1),
      form = _Form$useForm2[0];

  useImperativeHandle(parentRef, function () {
    return _objectSpread2({}, form);
  });
  var defaultSpan = 24 / column;

  var matchItem = function matchItem(field) {
    switch (field.valueType) {
      case 'select':
        return field.valueEnum ? /*#__PURE__*/React.createElement(Select, _objectSpread2({
          options: field.valueEnum
        }, field.fieldProps)) : null;

      case 'treeSelect':
        return /*#__PURE__*/React.createElement(TreeSelect, _objectSpread2({}, field.fieldProps));

      case 'date':
        return /*#__PURE__*/React.createElement(DatePicker, _objectSpread2({}, field.fieldProps));

      case 'dateRange':
        return /*#__PURE__*/React.createElement(DateRangePicker, _objectSpread2({}, field.fieldProps));

      case 'cascader':
        return /*#__PURE__*/React.createElement(Cascader, _objectSpread2({}, field.fieldProps));

      case 'custom':
        return field.children;

      default:
        return /*#__PURE__*/React.createElement(Input, _objectSpread2({}, field.fieldProps));
    }
  };

  var handleReset = function handleReset() {
    form.resetFields();

    if (onReset) {
      onReset();
    } else if (formProps === null || formProps === void 0 ? void 0 : formProps.onFinish) {
      var fields = form.getFieldsValue();
      (formProps === null || formProps === void 0 ? void 0 : formProps.onFinish) && (formProps === null || formProps === void 0 ? void 0 : formProps.onFinish(fields));
    }
  };

  var handleSubmit = /*#__PURE__*/function () {
    var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee() {
      var values;
      return regeneratorRuntime.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              _context.next = 2;
              return form.validateFields();

            case 2:
              values = form.getFieldsValue();
              onSearch && onSearch(values);

            case 4:
            case "end":
              return _context.stop();
          }
        }
      }, _callee);
    }));

    return function handleSubmit() {
      return _ref.apply(this, arguments);
    };
  }();

  return /*#__PURE__*/React.createElement(Form, _objectSpread2({
    className: classnames('iLab-filter-form', className),
    style: style,
    form: form,
    colon: false,
    layout: "vertical"
  }, formProps), /*#__PURE__*/React.createElement(Row, _objectSpread2({
    gutter: 16,
    className: "iLab-filter-form-row"
  }, rowProps), options.sort(function (a, b) {
    return (a.order || 0) - (b.order || 0);
  }).map(function (item, index) {
    var valueType = item.valueType,
        valueEnum = item.valueEnum,
        fieldProps = item.fieldProps,
        rest = _objectWithoutProperties(item, _excluded$5);

    return /*#__PURE__*/React.createElement(Col, _objectSpread2({
      key: index,
      span: defaultSpan,
      className: "iLab-filter-form-col"
    }, colProps), /*#__PURE__*/React.createElement(Form.Item, _objectSpread2({}, rest), matchItem(item)));
  })), /*#__PURE__*/React.createElement(Form.Item, null, /*#__PURE__*/React.createElement(Space, {
    size: 12
  }, renderCustomAction ? renderCustomAction() : showAction && /*#__PURE__*/React.createElement(Space, null, /*#__PURE__*/React.createElement(Button, {
    onClick: handleReset
  }, "\u91CD\u7F6E"), /*#__PURE__*/React.createElement(Button, {
    type: "primary",
    onClick: handleSubmit
  }, "\u67E5\u8BE2")))));
};

var FilterForm$1 = /*#__PURE__*/forwardRef(FilterForm);

var css_248z$3 = ".fr {\n  float: right;\n}\n";
styleInject(css_248z$3);

var _excluded$6 = ["title", "width", "options", "filterProps", "onChange", "onClose", "okText", "cancelText", "formProps", "children"];

var Index = function Index(props) {
  var _props$title = props.title,
      title = _props$title === void 0 ? '筛选' : _props$title,
      _props$width = props.width,
      width = _props$width === void 0 ? 500 : _props$width,
      options = props.options,
      filterProps = props.filterProps,
      onChange = props.onChange,
      onClose = props.onClose,
      _props$okText = props.okText,
      okText = _props$okText === void 0 ? '查询' : _props$okText,
      _props$cancelText = props.cancelText,
      cancelText = _props$cancelText === void 0 ? '重置' : _props$cancelText,
      formProps = props.formProps,
      _props$children = props.children,
      children = _props$children === void 0 ? /*#__PURE__*/React.createElement(Button, null, /*#__PURE__*/React.createElement(Icon$2, {
    type: 'icon-biaoge-shaixuan1'
  }), "\u7B5B\u9009") : _props$children,
      rest = _objectWithoutProperties(props, _excluded$6);

  var formRef = useRef(null);

  var _useState = useState(false),
      _useState2 = _slicedToArray(_useState, 2),
      visible = _useState2[0],
      setVisible = _useState2[1];

  var handleSubmit = function handleSubmit() {
    var _formRef$current;

    // @ts-ignore
    var fields = (formRef === null || formRef === void 0 ? void 0 : (_formRef$current = formRef.current) === null || _formRef$current === void 0 ? void 0 : _formRef$current.getFieldsValue()) || {};
    onChange(fields);
    setVisible(false);
  };

  var handleReset = /*#__PURE__*/function () {
    var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee() {
      var _formRef$current2, _formRef$current3;

      var fields;
      return regeneratorRuntime.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              _context.t0 = formRef.current;

              if (!_context.t0) {
                _context.next = 4;
                break;
              }

              _context.next = 4;
              return formRef === null || formRef === void 0 ? void 0 : (_formRef$current2 = formRef.current) === null || _formRef$current2 === void 0 ? void 0 : _formRef$current2.resetFields();

            case 4:
              // @ts-ignore
              fields = (formRef === null || formRef === void 0 ? void 0 : (_formRef$current3 = formRef.current) === null || _formRef$current3 === void 0 ? void 0 : _formRef$current3.getFieldsValue()) || {};
              onChange(fields);
              setVisible(false);

            case 7:
            case "end":
              return _context.stop();
          }
        }
      }, _callee);
    }));

    return function handleReset() {
      return _ref.apply(this, arguments);
    };
  }();

  return /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement(Drawer, _objectSpread2({
    title: title,
    width: width,
    onClose: function onClose() {
      return setVisible(false);
    },
    visible: visible,
    footer: /*#__PURE__*/React.createElement(Space, {
      className: "fr"
    }, /*#__PURE__*/React.createElement(Button, {
      onClick: handleReset
    }, cancelText), /*#__PURE__*/React.createElement(Button, {
      type: "primary",
      onClick: handleSubmit
    }, okText))
  }, rest), /*#__PURE__*/React.createElement(FilterForm$1, _objectSpread2({
    ref: formRef,
    options: options,
    formProps: formProps
  }, filterProps))), /*#__PURE__*/React.createElement("div", {
    onClick: function onClick() {
      return setVisible(true);
    }
  }, children));
};

var DrawerFilter = /*#__PURE__*/memo(Index);

var css_248z$4 = "/* 字体 */\n/* 行高 */\n@import '~antd/dist/antd.css';\n.iLab-table-filter {\n  position: relative;\n}\n.iLab-table-filter-fixed {\n  height: 86px;\n  transition: all 0.2s;\n}\n.iLab-table-filter-fixed.iLab-table-filter-expanded .iLab-table-filter-form {\n  position: absolute;\n  width: 100%;\n  padding: 12px 24px;\n  background-color: #ffffff;\n  box-shadow: 0 2px 8px 0 rgba(0, 0, 0, 0.1);\n  border-radius: 2px;\n  z-index: 9;\n}\n.iLab-table-filter-static {\n  height: 100%;\n}\n.iLab-table-filter-static.iLab-table-filter-expanded .iLab-table-filter-form {\n  padding-bottom: 12px;\n}\n.iLab-table-filter-collapsed {\n  overflow: hidden;\n}\n.iLab-table-filter-btn {\n  padding-left: 9px;\n  padding-right: 9px;\n}\n.iLab-table-filter .ant-picker,\n.iLab-table-filter .ant-picker-range {\n  display: flex;\n}\n";
styleInject(css_248z$4);

var _excluded$7 = ["valueEnum", "valueType", "fieldProps", "order", "show"];
var GUTTER = 16;
var SPAN = 6; // 收起时展示字段数

var LINE_COUNT = 3;

var TableFilter = function TableFilter(_ref) {
  var formProps = _ref.formProps,
      fields = _ref.fields,
      onSearch = _ref.onSearch,
      onReset = _ref.onReset,
      className = _ref.className,
      style = _ref.style,
      actionRef = _ref.actionRef,
      _ref$mode = _ref.mode,
      mode = _ref$mode === void 0 ? 'fixed' : _ref$mode,
      _ref$defaultCollapsed = _ref.defaultCollapsed,
      defaultCollapsed = _ref$defaultCollapsed === void 0 ? true : _ref$defaultCollapsed;

  var _Form$useForm = Form.useForm(),
      _Form$useForm2 = _slicedToArray(_Form$useForm, 1),
      form = _Form$useForm2[0]; // 是否收起


  var _useState = useState(defaultCollapsed),
      _useState2 = _slicedToArray(_useState, 2),
      collapsed = _useState2[0],
      setCollapsed = _useState2[1]; // 是否需要展开收起按钮


  var needCollapsedButton = fields.length > LINE_COUNT;
  useEffect(function () {
    var userAction = {
      getFieldsValue: function getFieldsValue() {
        return form.getFieldsValue();
      },
      setFieldsValue: function setFieldsValue(val) {
        return form.setFieldsValue(val);
      },
      resetFields: function resetFields() {
        return form.resetFields();
      }
    };

    if (actionRef && typeof actionRef !== 'function') {
      actionRef.current = userAction;
    }
  }, []);

  var matchItem = function matchItem(field) {
    switch (field.valueType) {
      case 'select':
        return field.valueEnum ? /*#__PURE__*/React.createElement(Select, _objectSpread2({
          options: field.valueEnum
        }, field.fieldProps)) : null;

      case 'treeSelect':
        return /*#__PURE__*/React.createElement(TreeSelect, _objectSpread2({}, field.fieldProps));

      case 'date':
        return /*#__PURE__*/React.createElement(DatePicker, _objectSpread2({}, field.fieldProps));

      case 'dateRange':
        return /*#__PURE__*/React.createElement(DateRangePicker, _objectSpread2({}, field.fieldProps));

      case 'cascader':
        return /*#__PURE__*/React.createElement(Cascader, _objectSpread2({}, field.fieldProps));

      default:
        return /*#__PURE__*/React.createElement(Input, _objectSpread2({}, field.fieldProps));
    }
  }; // 实际渲染字段


  var renderFields = function renderFields(data) {
    return data.sort(function (a, b) {
      return (a.order || 0) - (b.order || 0);
    }).map(function (item, index) {
      return _objectSpread2(_objectSpread2({}, item), {}, {
        show: index < LINE_COUNT || !collapsed
      });
    });
  }; // 搜索


  var search = function search() {
    var values = form.getFieldsValue();
    onSearch && onSearch(values);
  }; // 重置


  var reset = function reset() {
    form.resetFields();
    onReset && onReset();
  };

  if (!(fields instanceof Array && fields.length)) return null;
  return /*#__PURE__*/React.createElement("div", {
    className: classnames('iLab-table-filter', collapsed ? 'iLab-table-filter-collapsed' : 'iLab-table-filter-expanded', "iLab-table-filter-".concat(mode), className),
    style: style
  }, /*#__PURE__*/React.createElement(Form, _objectSpread2({
    className: "iLab-table-filter-form",
    layout: "vertical",
    form: form
  }, formProps), /*#__PURE__*/React.createElement(Row, {
    gutter: GUTTER
  }, renderFields(fields).map(function (filed) {
    var valueEnum = filed.valueEnum,
        valueType = filed.valueType,
        fieldProps = filed.fieldProps,
        order = filed.order,
        show = filed.show,
        rest = _objectWithoutProperties(filed, _excluded$7);

    return /*#__PURE__*/React.createElement(Col, {
      span: SPAN,
      key: filed.name,
      style: {
        display: filed.show ? 'block' : 'none'
      }
    }, /*#__PURE__*/React.createElement(Form.Item, _objectSpread2({}, rest), matchItem(filed)));
  }), /*#__PURE__*/React.createElement(Col, {
    span: SPAN,
    key: "actions"
  }, /*#__PURE__*/React.createElement(Form.Item, {
    label: " ",
    noStyle: renderFields(fields).filter(function (item) {
      return item.show;
    }).length % (LINE_COUNT + 1) === 0
  }, /*#__PURE__*/React.createElement(Space, null, /*#__PURE__*/React.createElement(Button, {
    className: "iLab-table-filter-btn",
    type: "primary",
    onClick: search
  }, "\u641C\u7D22"), /*#__PURE__*/React.createElement(Button, {
    className: "iLab-table-filter-btn",
    onClick: reset
  }, "\u91CD\u7F6E"), needCollapsedButton && /*#__PURE__*/React.createElement(Button, {
    icon: collapsed ? /*#__PURE__*/React.createElement(DownOutlined$2, null) : /*#__PURE__*/React.createElement(UpOutlined$2, null),
    onClick: function onClick() {
      setCollapsed(!collapsed);
    }
  })))))));
};

// 默认分页
var DEFAULT_PAGINATION = {
  current: 1,
  pageSize: 10
}; // 默认时间格式

var DEFAULT_DATE_TIME_FORMAT = 'yyyy-MM-DD HH:mm:ss'; // 默认空值

var DEFAULT_EMPTY_VALUE = '-';

var TableContext = /*#__PURE__*/React.createContext({
  id: 'basic',
  loading: false,
  setLoading: function setLoading() {},
  columns: [],
  setColumns: function setColumns() {},
  selectedDataIndex: [],
  setSelectedDataIndex: function setSelectedDataIndex() {},
  fetchData: function fetchData() {
    return Promise.resolve();
  }
});

var css_248z$5 = "/* 字体 */\n/* 行高 */\n.iLab-pro-table-toolbar-column-setting {\n  min-width: 120px;\n}\n.iLab-pro-table-toolbar-column-setting-header {\n  display: flex;\n  justify-content: space-between;\n  align-items: center;\n  padding: 4px 8px;\n  border-bottom: 1px solid #f2f2f2;\n}\n.iLab-pro-table-toolbar-column-setting-header-text {\n  color: #000;\n  font-weight: 600;\n}\n.iLab-pro-table-toolbar-column-setting-header .ant-btn {\n  padding: 0;\n}\n.iLab-pro-table-toolbar-column-setting-body {\n  padding: 4px 12px 10px;\n}\n.iLab-pro-table-toolbar-column-setting-body .ant-checkbox-group-item {\n  display: flex;\n  margin-right: 0;\n}\n";
styleInject(css_248z$5);

var ColumnSetting = function ColumnSetting() {
  var _useContext = useContext(TableContext),
      id = _useContext.id,
      columns = _useContext.columns,
      selectedDataIndex = _useContext.selectedDataIndex,
      setSelectedDataIndex = _useContext.setSelectedDataIndex;

  return /*#__PURE__*/React.createElement("div", {
    className: "iLab-pro-table-toolbar-column-setting"
  }, /*#__PURE__*/React.createElement("div", {
    className: "iLab-pro-table-toolbar-column-setting-header"
  }, /*#__PURE__*/React.createElement("span", {
    className: "iLab-pro-table-toolbar-column-setting-header-text"
  }, "\u5217\u5C55\u793A"), /*#__PURE__*/React.createElement(Typography.Link, {
    onClick: function onClick() {
      localStorage.setItem("".concat(window.location.pathname, "-").concat(id, "-Col"), columns.map(function (item) {
        return item.dataIndex;
      }).join());
      setSelectedDataIndex(columns.map(function (item) {
        return item.dataIndex;
      }));
    }
  }, "\u91CD\u7F6E")), /*#__PURE__*/React.createElement("div", {
    className: "iLab-pro-table-toolbar-column-setting-body"
  }, /*#__PURE__*/React.createElement(Checkbox.Group, {
    options: columns.map(function (item) {
      return {
        label: item.title,
        value: item.dataIndex
      };
    }),
    value: selectedDataIndex,
    onChange: function onChange(checkedValue) {
      localStorage.setItem("".concat(window.location.pathname, "-").concat(id, "-Col"), checkedValue.join());
      setSelectedDataIndex(checkedValue);
    }
  })));
};

var css_248z$6 = "/* 字体 */\n/* 行高 */\n@import '~antd/dist/antd.css';\n.iLab-pro-table-toolbar {\n  display: flex;\n  justify-content: space-between;\n  align-items: center;\n  margin-bottom: 8px;\n}\n.iLab-pro-table-toolbar-side-right {\n  display: flex;\n  align-items: center;\n}\n.iLab-pro-table-toolbar-options {\n  font-size: 18px;\n  line-height: 26px;\n  cursor: pointer;\n  margin-left: 16px;\n}\n.iLab-pro-table-toolbar-options-setting-popover .ant-popover-inner-content {\n  padding: 0;\n}\n";
styleInject(css_248z$6);

var Toolbar = function Toolbar(_ref) {
  var className = _ref.className,
      style = _ref.style,
      actions = _ref.actions,
      _ref$options = _ref.options,
      options = _ref$options === void 0 ? {} : _ref$options,
      slot = _ref.slot,
      showFilter = _ref.showFilter,
      fields = _ref.fields,
      drawerProps = _ref.drawerProps,
      formProps = _ref.formProps,
      onSearch = _ref.onSearch;
  var _options$refresh = options.refresh,
      refresh = _options$refresh === void 0 ? false : _options$refresh,
      _options$columnSettin = options.columnSetting,
      columnSetting = _options$columnSettin === void 0 ? false : _options$columnSettin;

  var _useContext = useContext(TableContext),
      loading = _useContext.loading,
      fetchData = _useContext.fetchData;

  var showOptionsBar = Object.values(options).some(function (item) {
    return item;
  });
  return /*#__PURE__*/React.createElement("div", {
    className: classnames('iLab-pro-table-toolbar', className),
    style: style
  }, /*#__PURE__*/React.createElement("div", {
    className: 'iLab-pro-table-toolbar-side-left'
  }, actions && /*#__PURE__*/React.createElement(Space, {
    className: 'iLab-pro-table-toolbar-actions'
  }, actions)), /*#__PURE__*/React.createElement("div", {
    className: 'iLab-pro-table-toolbar-side-right'
  }, /*#__PURE__*/React.createElement(Space, {
    className: 'iLab-pro-table-toolbar-slot'
  }, showFilter && fields && /*#__PURE__*/React.createElement(DrawerFilter, _objectSpread2({
    options: fields,
    onChange: function onChange(values) {
      return onSearch && onSearch(values);
    },
    formProps: formProps
  }, drawerProps)), slot), showOptionsBar && /*#__PURE__*/React.createElement(Space, {
    className: 'iLab-pro-table-toolbar-options',
    size: 12
  }, refresh && /*#__PURE__*/React.createElement(Icon$2, {
    type: 'icon-shuaxin',
    spin: loading,
    onClick: fetchData
  }), columnSetting && /*#__PURE__*/React.createElement(Popover, {
    overlayClassName: 'iLab-pro-table-toolbar-options-setting-popover',
    content: /*#__PURE__*/React.createElement(ColumnSetting, null),
    trigger: "click",
    placement: "bottomRight"
  }, /*#__PURE__*/React.createElement(Icon$2, {
    type: 'icon-ziduanshezhi'
  })))));
};

/**
 * 删除对象中所有的空值
 * @param obj
 */
var removeObjectNull = function removeObjectNull(obj) {
  var newObj = {};
  Object.keys(obj).forEach(function (key) {
    if (obj[key]) {
      newObj[key] = obj[key];
    }
  });
  return newObj;
};

var css_248z$7 = "/* 字体 */\n/* 行高 */\n@import '~antd/dist/antd.css';\n.iLab-pro-table {\n  padding: 16px;\n  background-color: #ffffff;\n  border-radius: 6px;\n}\n.iLab-pro-table .ant-table-thead > tr > th {\n  background: #e3eaf1;\n}\n.iLab-pro-table .ant-table-container table > thead > tr:first-child th:first-child {\n  border-top-left-radius: 6px;\n}\n.iLab-pro-table .ant-table-container table > thead > tr:first-child th:last-child {\n  border-top-right-radius: 16px;\n}\n.iLab-pro-table .ant-pagination-total-text {\n  flex: 1;\n}\n.iLab-pro-table .ant-table {\n  border-radius: 16px 16px 0 0;\n  overflow: hidden;\n}\n.iLab-pro-table .empty-container img {\n  max-width: 200px;\n}\n.iLab-pro-table .empty-container div {\n  position: relative;\n  top: -20px;\n  text-align: center;\n  color: #8791a3;\n}\n";
styleInject(css_248z$7);

var _excluded$8 = ["id", "request", "params", "columns", "className", "style", "tableClassName", "tableStyle", "formClassName", "formStyle", "formProps", "formMode", "toolbar", "actionRef", "defaultPagination", "defaultCollapsed", "drawerProps", "pagination", "remember", "onFilterSearch", "onFilterReset"];

var ProTable = function ProTable(props) {
  var _props$id = props.id,
      id = _props$id === void 0 ? 'basic' : _props$id,
      request = props.request,
      params = props.params,
      columns = props.columns,
      className = props.className,
      style = props.style,
      tableClassName = props.tableClassName,
      tableStyle = props.tableStyle,
      formClassName = props.formClassName,
      formStyle = props.formStyle,
      formProps = props.formProps,
      formMode = props.formMode,
      toolbar = props.toolbar,
      actionRef = props.actionRef,
      _props$defaultPaginat = props.defaultPagination,
      defaultPagination = _props$defaultPaginat === void 0 ? DEFAULT_PAGINATION : _props$defaultPaginat,
      defaultCollapsed = props.defaultCollapsed,
      drawerProps = props.drawerProps,
      pagination = props.pagination,
      remember = props.remember,
      onFilterSearch = props.onFilterSearch,
      onFilterReset = props.onFilterReset,
      rest = _objectWithoutProperties(props, _excluded$8);

  var history = useHistory();
  var pathname = history.location.pathname; // loading 状态

  var _useState = useState(false),
      _useState2 = _slicedToArray(_useState, 2),
      loading = _useState2[0],
      setLoading = _useState2[1]; // 表格字段


  var _useState3 = useState([]),
      _useState4 = _slicedToArray(_useState3, 2),
      tableColumns = _useState4[0],
      setTableColumns = _useState4[1]; // 选中列字段


  var _useState5 = useState([]),
      _useState6 = _slicedToArray(_useState5, 2),
      selectedDataIndex = _useState6[0],
      setSelectedDataIndex = _useState6[1]; // 表格数据


  var _useState7 = useState([]),
      _useState8 = _slicedToArray(_useState7, 2),
      list = _useState8[0],
      setList = _useState8[1]; // 数据总条数


  var _useState9 = useState(0),
      _useState10 = _slicedToArray(_useState9, 2),
      total = _useState10[0],
      setTotal = _useState10[1]; // 分页数据


  var _useState11 = useState(defaultPagination),
      _useState12 = _slicedToArray(_useState11, 2),
      page = _useState12[0],
      setPage = _useState12[1]; // 排序


  var _useState13 = useState({}),
      _useState14 = _slicedToArray(_useState13, 2),
      proSort = _useState14[0],
      setProSort = _useState14[1]; // 筛选


  var _useState15 = useState({}),
      _useState16 = _slicedToArray(_useState15, 2),
      proFilter = _useState16[0],
      setProFilter = _useState16[1];

  var tableFilterRef = useRef();

  var _useState17 = useState((formProps === null || formProps === void 0 ? void 0 : formProps.initialValues) || {}),
      _useState18 = _slicedToArray(_useState17, 2),
      formData = _useState18[0],
      setFormData = _useState18[1];

  var UNLISTEN;
  useEffect(function () {
    // 设置表格字段内容
    setTableColumns(formatColumns(columns));
  }, [columns]);
  useEffect(function () {
    fetchData();
  }, [params, page, proSort, setProFilter]);
  useEffect(function () {
    if (remember) {
      UNLISTEN = history.listen(function (location) {
        if (!location.pathname.includes(pathname)) {
          // 跳转详情不清空page
          localStorage.removeItem("".concat(pathname, "-").concat(id, "-Page"));
        }
      });
      var localPagination = getParamsStorage('Page');
      setPage(localPagination && JSON.parse(localPagination) || defaultPagination);
    }

    return function () {
      UNLISTEN && UNLISTEN();
    };
  }, []);
  useEffect(function () {
    // 给 actionRef 方法赋值
    var userAction = {
      reload: function () {
        var _reload = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(resetPageIndex) {
          return regeneratorRuntime.wrap(function _callee$(_context) {
            while (1) {
              switch (_context.prev = _context.next) {
                case 0:
                  if (!resetPageIndex) {
                    _context.next = 5;
                    break;
                  }

                  setParamsStorage('Page', defaultPagination);
                  setPage(_.cloneDeep(defaultPagination));
                  _context.next = 7;
                  break;

                case 5:
                  _context.next = 7;
                  return fetchData();

                case 7:
                case "end":
                  return _context.stop();
              }
            }
          }, _callee);
        }));

        function reload(_x) {
          return _reload.apply(this, arguments);
        }

        return reload;
      }(),
      getFilterValue: function getFilterValue() {
        var _tableFilterRef$curre;

        return ((_tableFilterRef$curre = tableFilterRef.current) === null || _tableFilterRef$curre === void 0 ? void 0 : _tableFilterRef$curre.getFieldsValue()) || {};
      },
      setFilterValue: function setFilterValue(val) {
        var _tableFilterRef$curre2;

        return (_tableFilterRef$curre2 = tableFilterRef.current) === null || _tableFilterRef$curre2 === void 0 ? void 0 : _tableFilterRef$curre2.setFieldsValue(val);
      },
      resetFilter: function resetFilter() {
        var _tableFilterRef$curre3;

        return (_tableFilterRef$curre3 = tableFilterRef.current) === null || _tableFilterRef$curre3 === void 0 ? void 0 : _tableFilterRef$curre3.resetFields();
      }
    };

    if (actionRef && typeof actionRef === 'function') {
      actionRef(userAction);
    }

    if (actionRef && typeof actionRef !== 'function') {
      actionRef.current = userAction;
    }
  }, [props]); // 存取Storage

  var getParamsStorage = function getParamsStorage(type) {
    return localStorage.getItem("".concat(pathname, "-").concat(id, "-").concat(type));
  };

  var setParamsStorage = function setParamsStorage(type, param) {
    remember && param && localStorage.setItem("".concat(pathname, "-").concat(id, "-").concat(type), JSON.stringify(param));
  }; // 表单渲染字段


  var fields = columns.filter(function (item) {
    return item.search;
  }).filter(function (item) {
    return item.valueType !== 'option';
  }).map(function (item) {
    var _item$fieldProps;

    return {
      label: ((_item$fieldProps = item.fieldProps) === null || _item$fieldProps === void 0 ? void 0 : _item$fieldProps.label) || item.title,
      name: item.dataIndex,
      valueType: item.valueType || 'text',
      valueEnum: item.valueEnum,
      fieldProps: item.fieldProps,
      order: item.order
    };
  }).map(function (item) {
    var map = new Map();
    item.valueEnum && Array.from(item.valueEnum).forEach(function (e) {
      map.set(e[0], _typeof(e[1]) === 'object' ? e[1].text : e[1]);
    });
    return _objectSpread2(_objectSpread2({}, item), {}, {
      valueEnum: item.valueEnum ? map : undefined
    });
  }); // 表格渲染字段

  var formatColumns = function formatColumns(cols) {
    var ret = cols.filter(function (item) {
      return !item.hideInTable;
    }).map(function (item) {
      // 如果存在自定义渲染方法，则优先执行
      if (item.render) return item; // 枚举值处理

      if (item.valueType === 'select' && item.valueEnum) {
        return _objectSpread2(_objectSpread2({}, item), {}, {
          render: function render(value) {
            var v = item.valueEnum.get(value);
            if (isInvalidValue(v)) return DEFAULT_EMPTY_VALUE;

            if (_typeof(v) === 'object') {
              return /*#__PURE__*/React.createElement(Badge, {
                status: v.status,
                text: v.text
              });
            }

            return v;
          }
        });
      } // 时间类型数据处理


      if (item.valueType === 'date') {
        return _objectSpread2(_objectSpread2({}, item), {}, {
          render: function render(value) {
            return isInvalidValue(value) ? DEFAULT_EMPTY_VALUE : moment(value).format(item.dateTimeFormat || DEFAULT_DATE_TIME_FORMAT);
          }
        });
      }

      return _objectSpread2(_objectSpread2({}, item), {}, {
        render: function render(value) {
          return isInvalidValue(value) ? DEFAULT_EMPTY_VALUE : value;
        }
      });
    }); // 从localStorage取 || 全部选中

    var resetColumn = getParamsStorage('Col') ? (getParamsStorage('Col') || '').split(',') : ret.map(function (item) {
      return item.dataIndex;
    });
    setSelectedDataIndex(resetColumn);
    return ret;
  }; // 过滤未选中字段


  var filterUnselectedColumns = function filterUnselectedColumns(cols) {
    return cols.filter(function (item) {
      return selectedDataIndex.includes(item.dataIndex);
    });
  }; // 格式化请求参数


  var getFetchParams = function getFetchParams() {
    var _tableFilterRef$curre4;

    var obj = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
    // 获取查询条件
    var query = (toolbar === null || toolbar === void 0 ? void 0 : toolbar.showFilter) ? formData : (_tableFilterRef$curre4 = tableFilterRef.current) === null || _tableFilterRef$curre4 === void 0 ? void 0 : _tableFilterRef$curre4.getFieldsValue();

    var p = _objectSpread2(_objectSpread2({}, query), {}, {
      current: page.current,
      pageSize: page.pageSize
    }, obj); // 外部传入的参数优先级最高


    if (params) {
      return _objectSpread2(_objectSpread2({}, p), params);
    }

    return p;
  }; // 获取数据


  var fetchData = /*#__PURE__*/function () {
    var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2() {
      var fetchParams, res, success, data, paginationTotal;
      return regeneratorRuntime.wrap(function _callee2$(_context2) {
        while (1) {
          switch (_context2.prev = _context2.next) {
            case 0:
              fetchParams = getFetchParams();

              if (request) {
                _context2.next = 3;
                break;
              }

              return _context2.abrupt("return");

            case 3:
              setLoading(true);
              _context2.prev = 4;
              _context2.next = 7;
              return request(fetchParams, proSort, proFilter);

            case 7:
              res = _context2.sent;
              success = res.success, data = res.data, paginationTotal = res.total;

              if (success) {
                setList(data || []);
                setTotal(paginationTotal || 0);
              }

              setLoading(false);
              _context2.next = 17;
              break;

            case 13:
              _context2.prev = 13;
              _context2.t0 = _context2["catch"](4);
              console.log(_context2.t0);
              setLoading(false);

            case 17:
            case "end":
              return _context2.stop();
          }
        }
      }, _callee2, null, [[4, 13]]);
    }));

    return function fetchData() {
      return _ref.apply(this, arguments);
    };
  }(); // 搜索


  var onTableFilterSearch = /*#__PURE__*/function () {
    var _ref2 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee3(values) {
      return regeneratorRuntime.wrap(function _callee3$(_context3) {
        while (1) {
          switch (_context3.prev = _context3.next) {
            case 0:
              if (onFilterSearch) {
                onFilterSearch(values);
              }

              if (toolbar === null || toolbar === void 0 ? void 0 : toolbar.showFilter) setFormData(values);

              try {
                setParamsStorage('Page', {
                  current: 1,
                  pageSize: defaultPagination.pageSize
                });
                setPage({
                  current: 1,
                  pageSize: defaultPagination.pageSize
                });
              } catch (err) {
                console.log(err);
              }

            case 3:
            case "end":
              return _context3.stop();
          }
        }
      }, _callee3);
    }));

    return function onTableFilterSearch(_x2) {
      return _ref2.apply(this, arguments);
    };
  }(); // 搜索重置


  var onTableFilterReset = /*#__PURE__*/function () {
    var _ref3 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee4() {
      return regeneratorRuntime.wrap(function _callee4$(_context4) {
        while (1) {
          switch (_context4.prev = _context4.next) {
            case 0:
              if (onFilterReset) {
                onFilterReset();
              }

              if (toolbar === null || toolbar === void 0 ? void 0 : toolbar.showFilter) setFormData({});

              try {
                setParamsStorage('Page', {
                  current: 1,
                  pageSize: defaultPagination.pageSize
                });
                setPage({
                  current: 1,
                  pageSize: defaultPagination.pageSize
                });
              } catch (err) {
                console.log(err);
              }

            case 3:
            case "end":
              return _context4.stop();
          }
        }
      }, _callee4);
    }));

    return function onTableFilterReset() {
      return _ref3.apply(this, arguments);
    };
  }(); // 改变页码


  var handlePageChange = /*#__PURE__*/function () {
    var _ref4 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee5(current) {
      var pageSize,
          _args5 = arguments;
      return regeneratorRuntime.wrap(function _callee5$(_context5) {
        while (1) {
          switch (_context5.prev = _context5.next) {
            case 0:
              pageSize = _args5.length > 1 && _args5[1] !== undefined ? _args5[1] : defaultPagination.pageSize;
              setParamsStorage('Page', {
                current: current,
                pageSize: pageSize
              });
              setPage({
                current: current,
                pageSize: pageSize
              });

            case 3:
            case "end":
              return _context5.stop();
          }
        }
      }, _callee5);
    }));

    return function handlePageChange(_x3) {
      return _ref4.apply(this, arguments);
    };
  }(); // 改变 pageSize


  var handlePageSizeChange = /*#__PURE__*/function () {
    var _ref5 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee6(current, size) {
      return regeneratorRuntime.wrap(function _callee6$(_context6) {
        while (1) {
          switch (_context6.prev = _context6.next) {
            case 0:
              setParamsStorage('Page', {
                current: current,
                pageSize: size
              });
              setPage({
                current: current,
                pageSize: size
              });

            case 2:
            case "end":
              return _context6.stop();
          }
        }
      }, _callee6);
    }));

    return function handlePageSizeChange(_x4, _x5) {
      return _ref5.apply(this, arguments);
    };
  }(); // 判断无效值


  var isInvalidValue = function isInvalidValue(val) {
    return val === undefined || val === null;
  };

  return /*#__PURE__*/React.createElement(ConfigProvider, {
    locale: zhCN
  }, /*#__PURE__*/React.createElement(TableContext.Provider, {
    value: {
      id: id,
      loading: loading,
      setLoading: setLoading,
      columns: tableColumns,
      setColumns: setTableColumns,
      selectedDataIndex: selectedDataIndex,
      setSelectedDataIndex: setSelectedDataIndex,
      fetchData: fetchData
    }
  }, /*#__PURE__*/React.createElement("div", {
    id: id,
    className: classnames("iLab-pro-table", className),
    style: style
  }, !(toolbar === null || toolbar === void 0 ? void 0 : toolbar.showFilter) && /*#__PURE__*/React.createElement(TableFilter, {
    className: classnames('iLab-pro-table-filter', formClassName),
    style: formStyle,
    fields: fields,
    onSearch: onTableFilterSearch,
    onReset: onTableFilterReset,
    formProps: formProps,
    mode: formMode,
    defaultCollapsed: defaultCollapsed,
    actionRef: tableFilterRef
  }), toolbar && /*#__PURE__*/React.createElement(Toolbar, _objectSpread2(_objectSpread2({}, toolbar), {}, {
    fields: fields,
    drawerProps: drawerProps,
    formProps: formProps,
    onSearch: onTableFilterSearch,
    onReset: onTableFilterReset
  })), /*#__PURE__*/React.createElement(Table, _objectSpread2({
    className: classnames('iLab-pro-table-table', tableClassName),
    style: tableStyle,
    columns: filterUnselectedColumns(tableColumns),
    dataSource: list,
    loading: loading,
    locale: {
      emptyText: /*#__PURE__*/React.createElement("div", {
        className: "empty-container"
      }, /*#__PURE__*/React.createElement("img", {
        src: require("@/assets/noData.png")
      }), /*#__PURE__*/React.createElement("div", null, "\u6682\u65E0\u6570\u636E"))
    },
    pagination: _objectSpread2(_objectSpread2({}, pagination), {}, {
      current: page.current,
      pageSize: page.pageSize,
      total: total,
      showQuickJumper: false,
      showSizeChanger: true,
      showTotal: function showTotal(t) {
        return "\u5171".concat(t, "\u6761");
      },
      onChange: handlePageChange,
      onShowSizeChange: handlePageSizeChange
    }),
    onChange: function onChange(changePagination, filters, sorter, extra) {
      if (rest.onChange) {
        rest.onChange(changePagination, filters, sorter, extra);
      } // 制造筛选的数据


      setProFilter(removeObjectNull(filters)); // 修改排序字段及排序方式

      if (Array.isArray(sorter)) {
        var data = sorter.reduce(function (pre, value) {
          if (!value.order) {
            return pre;
          }

          return _objectSpread2(_objectSpread2({}, pre), {}, _defineProperty({}, "".concat(value.field), value.order));
        }, {});
        setProSort(data);
      } else if (sorter.order) {
        setProSort(_defineProperty({}, "".concat(sorter.field), sorter.order));
      } else {
        setProSort({});
      }
    }
  }, rest)))));
};

var css_248z$8 = "/* 字体 */\n/* 行高 */\n@import '~antd/dist/antd.css';\n.uniubi-footer-bar {\n  position: fixed;\n  bottom: 0;\n  left: 0;\n  width: 100%;\n  border-top: 1px solid #f2f2f2;\n  background-color: #ffffff;\n}\n.uniubi-footer-bar-content {\n  display: flex;\n  justify-content: center;\n  align-items: center;\n  padding: 10px 0;\n}\n";
styleInject(css_248z$8);

var FooterBar = function FooterBar(props) {
  var className = props.className,
      style = props.style,
      _props$collapsed = props.collapsed,
      collapsed = _props$collapsed === void 0 ? false : _props$collapsed,
      _props$normalPadding = props.normalPadding,
      normalPadding = _props$normalPadding === void 0 ? 200 : _props$normalPadding,
      _props$collapsedPaddi = props.collapsedPadding,
      collapsedPadding = _props$collapsedPaddi === void 0 ? 48 : _props$collapsedPaddi,
      _props$zIndex = props.zIndex,
      zIndex = _props$zIndex === void 0 ? 1 : _props$zIndex,
      children = props.children;
  return /*#__PURE__*/React.createElement("div", {
    className: classnames('uniubi-footer-bar', {
      'uniubi-footer-bar-collapsed': collapsed
    }, className),
    style: _objectSpread2({
      paddingLeft: collapsed ? collapsedPadding : normalPadding,
      zIndex: zIndex
    }, style)
  }, /*#__PURE__*/React.createElement("div", {
    className: "uniubi-footer-bar-content"
  }, children));
};

var css_248z$9 = "/* 字体 */\n/* 行高 */\n@import '~antd/dist/antd.css';\n.iLab-cardDetail .ant-card-head-title {\n  font-size: 20px;\n  color: #344563;\n  font-family: PingFangSC-Medium, PingFang SC;\n  font-weight: 500;\n}\n.iLab-cardDetail .ant-card-head {\n  border-bottom: 0;\n}\n.iLab-cardDetail .ant-card-body {\n  padding: 0 24px 24px;\n}\n";
styleInject(css_248z$9);

function CardDetail(props) {
  var className = props.className,
      _props$list = props.list,
      list = _props$list === void 0 ? [] : _props$list,
      _props$column = props.column,
      column = _props$column === void 0 ? 4 : _props$column,
      listProps = props.listProps,
      children = props.children;
  return /*#__PURE__*/React.createElement(Card, _objectSpread2({
    className: classnames('iLab-cardDetail', className)
  }, props), /*#__PURE__*/React.createElement(Descriptions, _objectSpread2({
    column: column
  }, listProps), list.map(function (item, index) {
    return /*#__PURE__*/React.createElement(Descriptions.Item, {
      key: index,
      label: item.label
    }, item.value);
  })), children && /*#__PURE__*/React.createElement(Divider, null), children);
}

export { Caption, CardDetail, DrawerFilter, EllipsisLine, FilterForm$1 as FilterForm, FooterBar, Icon$2 as Icon, ProTable, TableFilter };
